# -*- coding: utf-8 -*-
"""
Created on Sun Mar 25 16:32:14 2018

@author: Callie Darsey

Computing a range of motion maginitude to notice
"""


import cv2
import numpy as np
import pickle
import os
import fns_investigating_optical_flow_01 as fns
from matplotlib import pyplot as plt

# video path
common_path = './video_copies_clips_track/copies_and_clips_facilitator_C/'

specific_paths = ['STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__10_18/',
                  'STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__60_68/',
                  'STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__96_104/',
                  'STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__260_270/',
                  'STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__342_352/',
                  'STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__430_442/',
                  'STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__496_502/',
                  'STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__605_615/',
                  'STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__680_690/',
                  'STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__780_790/']
video_names    = ['MVI_0028_trans__10_18.mp4',
                  'MVI_0028_trans__60_68.mp4',
                  'MVI_0028_trans__96_104.mp4',
                  'MVI_0028_trans__260_270.mp4',
                  'MVI_0028_trans__342_352.mp4',
                  'MVI_0028_trans__430_442.mp4',
                  'MVI_0028_trans__496_502.mp4',
                  'MVI_0028_trans__605_615.mp4',
                  'MVI_0028_trans__680_690.mp4',
                  'MVI_0028_trans__780_790.mp4']
exemplar_names = \
['exemplars___MVI_0028_trans__10_18___y2018m03d25-h16m26s20.745683__for_now.data',
 'exemplars___MVI_0028_trans__60_68___y2018m03d25-h22m52s48.511896__for_now.data',
 'exemplars___MVI_0028_trans__96_104___y2018m03d25-h23m26s38.589296__for_now.data',
 'exemplars___MVI_0028_trans__260_270___y2018m03d25-h23m43s18.461254_for_now.data',
 'exemplars___MVI_0028_trans__342_352___y2018m03d26-h00m31s25.739535_for_now.data',
 'exemplars___MVI_0028_trans__430_442___y2018m03d26-h00m39s27.524902_for_now.data',
 'exemplars___MVI_0028_trans__496_502___y2018m03d26-h01m12s27.222854_for_now.data',
 'exemplars___MVI_0028_trans__605_615___y2018m03d26-h01m30s42.70924__for_now.data',
 'exemplars___MVI_0028_trans__680_690___y2018m03d26-h01m58s06.511145_for_now.data',
 'exemplars___MVI_0028_trans__780_790___y2018m03d26-h02m37s51.868626_for_now.data']


for specific_path, video_name, exemplar_name in zip(specific_paths,
                                                    video_names,
                                                    exemplar_names):
        
    with open(common_path + specific_path + exemplar_name, 'rb') as f:
        
        exemplar_info = pickle.load(f)
        
    frame_list = []
    for frame_number, boxes in exemplar_info.items():
        
        if not boxes is None:
            frame_list.append('{:04d}'.format(frame_number))
    
    
    directory = common_path + specific_path
    
    dir_list = os.listdir(directory)
    
    collect_listings = []
    
    for listing in dir_list:
        
        if 'flow_' + video_name[0:-4] in listing and listing[-5:] == '.data' and \
            listing[-14:-10] in frame_list:
            
            collect_listings.append(listing)
    
    collect_listings.sort()
    frame_list.sort()
    
    flow_mag_collection = []
    
    for listing, frame_number_str in zip(collect_listings, frame_list):
        
        # pickle result
        pickle_path = common_path + specific_path + listing
            
        with open(pickle_path, 'rb') as f:
            frame1, frame2, flow, arrows = pickle.load(f)
            
        flow_mag = cv2.magnitude(flow[:, :, 0], flow[:, :, 1])
        
        # make exemplars mask
        exemplars_mask = np.zeros(frame1.shape[0:2], dtype=np.uint8)
        for points in exemplar_info[int(frame_number_str)]:
            
            color = 255  # grayscale
            thickness = -1 # -1 for filled
            cv2.rectangle(exemplars_mask, tuple(points[0:2]), tuple(points[2:]),
                          color, thickness)
            
        flow_mag_collection.append(flow_mag[exemplars_mask != 0])

#        cv2.imshow('title', cv2.bitwise_and(arrows, arrows,
#                                            mask=exemplars_mask))
#        cv2.waitKey(0)
#        
#cv2.destroyAllWindows()
 
flow_mag_samples = np.hstack(flow_mag_collection)

with open(common_path + specific_path[0:32] + 'flow_mag_samples.data', 'wb') as f:
    
    pickle.dump((flow_mag_samples, specific_paths,
                 video_names, exemplar_names), f)
    
bp1 = plt.boxplot(np.reshape(flow_mag_samples, -1))
plt.show()


    
    
    
    
    
    
    
    
    
    
    
    
    
    