# -*- coding: utf-8 -*-
"""
Created on Wed May  9 18:34:10 2018

@author: Callie Darsey

check out the exemplar sizes

exemplars___M - marked - arrow

check_exemplar_sizes_01
"""

import cv2
import numpy as np
import pickle
import matplotlib.pyplot as plt
import os

directory_w = "./wheeler/dataset/STI_WA_May02_C/MVI_0074_trans/"

directory = "./video_copies_clips_track/copies_and_clips_wave_04/" + \
            "STI WA May02 C/MVI_0074_trans/"

for content in os.listdir(directory_w):
    
    print(content)
    
    if os.path.isfile(directory_w + content):
        
        if content[-12:] == '.sampled.mp4':
            
            name = content[:-12]
            
            break
                                   
cap_flow_mag = cv2.VideoCapture(directory_w+'flow_'+name+'.flow_mag.mp4')
cap_flow_ang = cv2.VideoCapture(directory_w+'flow_'+name+'.flow_ang.mp4')


with open(directory + 'exemplars_and_labels___' + name + '.data',
          'rb') as f:
    
    exemplars_and_labels = pickle.load(f)
    
exemplar_info = {}

keys = np.array(list(exemplars_and_labels.keys()))


segment = 45

segment_flow_mag = []
segment_flow_ang = []

count = -1
ind = -1
            
set_size = (28, 28)

height = []
width = []
area = []

while(cap_flow_mag.isOpened() and cap_flow_ang.isOpened()):
    
    success_flag_flow_mag, flow_mag_display = cap_flow_mag.read()
    success_flag_flow_ang, flow_ang_display = cap_flow_ang.read()
    
    if success_flag_flow_mag == True and success_flag_flow_ang == True:
        
        count = count + 1

        segment_flow_mag.append(flow_mag_display)
        segment_flow_ang.append(flow_ang_display)
    
        if len(segment_flow_mag) > segment:
            segment_flow_mag.pop(0)
            segment_flow_ang.pop(0)

        else:
            ind = ind + 1

        if count != 0 and (count + 1) % segment == 0:
            
            print('segment', int(np.floor(count / segment)))
            
            index = np.where(keys[:, 1] == count * 4)[0]
            
            if len(index) == 1:
                
                exemplars, tags = \
                    exemplars_and_labels[(keys[index[0], 0],
                                          keys[index[0], 1])]
                    
                feature_vectors = np.zeros((exemplars.shape[0],
                                            set_size[0] * set_size[1]))
                
                for i, box in enumerate(exemplars):

                    col_1, col_2 = np.sort([box[0], box[2]])
                    
                    row_1, row_2 = np.sort([box[1], box[3]])
                    
                    height.append((row_2 - row_1 + 1))
                    width.append((col_2 - col_1 + 1))
                    area.append((row_2 - row_1 + 1) * (col_2 - col_1 + 1))

    else:
        
        print("No more frames")
        
        cap_flow_mag.release()
        cap_flow_ang.release()
                
        break        
else:
    
    cap_flow_mag.release()
    cap_flow_ang.release()


bp_height = plt.boxplot(height)
plt.show()
print('Height: ', 'min {:3d}, median {:3d}, mean {:3d}, max {:3d}'.format(\
      int(np.min(height)), int(np.median(height)),
      int(np.mean(height)), int(np.max(height))))     

bp_width = plt.boxplot(width)
plt.show()
print('Width: ', 'min {:3d}, median {:3d}, mean {:3d}, max {:3d}'.format(\
      int(np.min(width)), int(np.median(width)),
      int(np.mean(width)), int(np.max(width))))

bp_width = plt.boxplot(area)
plt.show()
print('Area: ', 'min {:3d}, median {:3d}, mean {:3d}, max {:3d}'.format(\
      int(np.min(area)), int(np.median(area)),
      int(np.mean(area)), int(np.max(area))))   