# -*- coding: utf-8 -*-
"""
Created on Sun Apr 15 17:33:29 2018

@author: Callie Darsey

Save classified mask pictures as pictures.
"""

import pickle
import get_lessened_features_and_save_steps_03 as get
import os
import cv2
import patches_01 as patches

# load the skin patch classifier
block_dim = 5
k = 5

path = './video_copies_clips_track/ROI_masks_patch_detection/'
save = path + "block_feature_vectors/"

with open(save + \
          'knn_{:03}_block_dim_{:02d}.data'.format(k, block_dim), 'rb') as f:
    
    clf_knn = pickle.load(f)
    
    
## get masks on the training pictures
roi_path = './video_copies_clips_track/ROI_masks_patch_detection/'
filenames = [f for f in os.listdir(roi_path) if os.path.isfile(roi_path + f)]

# directory for classify the training pictures
classify_training = roi_path + 'classified_training_block_dim_05/'
if not os.path.isdir(classify_training):
    
    os.mkdir(classify_training)

# get the masks and save
for filename in filenames:
    
    with open(path + filename, 'rb') as f:
        
        roi_masks, frame = pickle.load(f)    
        
    skin_mask = \
        get.detect_skin_patches(frame, clf_knn, block_dim)

    # save mask picture
    skin_mask_display = cv2.bitwise_and(frame, frame, mask=skin_mask)
    
    # save the picture
    cv2.imwrite(classify_training + 'classified_patch_skin_mask_' + \
                filename[0:-5] + '.png', skin_mask_display)


# classified frames from videos where frame(s) were taken as training
commons = ['./video_copies_clips_track/copies_and_clips/',
           './video_copies_clips_track/copies_and_clips/',
           './video_copies_clips_track/copies_and_clips/',
           './video_copies_clips_track/copies_and_clips/',
           './video_copies_clips_track/copies_and_clips/',
           './video_copies_clips_track/copies_and_clips/',
           './video_copies_clips_track/copies_and_clips/',
           './video_copies_clips_track/copies_and_clips_wave_02/']

specifics = ['STI Polk Apr13 E/MVI_0044_trans/PNGs/',
             'STI Polk Apr20 C/MVI_0053_trans/PNGs/',
             'STI Polk May04 F/MVI_0079_trans/PNGs/',
             'STI WA Apr18 B/MVI_0029_trans/PNGs/',
             'STI WA Apr25 A/STI WA Apr25 AMVI_0068_trans/PNGs/',
             'STI WA Mar28 C/MVI_0013_trans/PNGs/',
             'STI WA May06 Polk B/MVI_0091_trans/PNGs/',
             'STI Polk Mar30 F/MVI_0025_trans/PNGs/']
filenames = ['MVI_0044_trans__350_365_0788.png',
             'MVI_0053_trans__50_72_1120.png',
             'MVI_0079_trans__390_415_1316.png',
             'MVI_0029_trans__75_125_2592.png',
             'STI WA Apr25 AMVI_0068_trans__860_910_0076.png',
             'MVI_0013_trans__110_140_1628.png',
             'MVI_0091_trans__60_85_1288.png',
             'MVI_0025_trans__250_280_1628.png']

# directory to save in
classify_frames = roi_path + 'classified_frames_block_dim_05/'
if not os.path.isdir(classify_frames):
    
    os.mkdir(classify_frames)


for common, specific, filename in zip(commons, specifics, filenames):
    
    path = common + specific + filename
    print(path)

    frame = cv2.imread(path)
    
    # time first function I wrote
    e1 = cv2.getTickCount()
      
    skin_mask = get.detect_skin_patches(frame, clf_knn, block_dim)
    
    skin_mask_display = cv2.bitwise_and(frame, frame, mask=skin_mask)
    
    cv2.imwrite(classify_frames + 'classified_patch_skin_mask_' + \
                filename[0:-5] + '.png', skin_mask_display)
    
    e2 = cv2.getTickCount()
    time = (e2 - e1)/ cv2.getTickFrequency()
    print("Total execution time in seconds = ", time)



# classify frame from video where frames were not taken for training

# directory
classify_val = roi_path + 'classified_val_block_dim_05/'
if not os.path.isdir(classify_val):
    
    os.mkdir(classify_val)
    

commons = ['./video_copies_clips_track/copies_and_clips_facilitator_C/']

specifics = ['STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__200_208/PNGS/']
filenames = ['MVI_0028_trans__200_208_0000.png',]

for common, specific, filename in zip(commons, specifics, filenames):
    
    path = common + specific + filename
    print(path)

    frame = cv2.imread(path)
    
    # time first function I wrote
    e1 = cv2.getTickCount()
      
    skin_mask = get.detect_skin_patches(frame, clf_knn, block_dim)
    
    skin_mask_display = cv2.bitwise_and(frame, frame, mask=skin_mask)
    
    cv2.imwrite(classify_val + 'classified_patch_skin_mask_' + \
                filename[0:-5] + '.png', skin_mask_display)
    
    e2 = cv2.getTickCount()
    time = (e2 - e1)/ cv2.getTickFrequency()
    print("Total execution time in seconds = ", time)
