# -*- coding: utf-8 -*-
"""
Created on Wed May  9 12:22:51 2018

@author: Callie Darsey

combine_segments_01
"""

import numpy as np

def combine(crop1, crop2):
    '''
    '''
    mask1 = np.any(crop1, axis=2)
    mask2 = np.any(crop2, axis=2)
    
    intersection = np.logical_and(mask1, mask2)
    xor_mask1 = np.logical_xor(mask1, intersection)
    xor_mask2 = np.logical_xor(mask2, intersection)    

    pred_side_1 = np.copy(crop1)
    pred_side_2 = np.copy(crop2)
    
    np.copyto(pred_side_1, crop2,
              where=np.stack([xor_mask2, xor_mask2, xor_mask2], axis=2))
    np.copyto(pred_side_2, crop1,
              where=np.stack([xor_mask1, xor_mask1, xor_mask1], axis=2))

    alpha = 0.5
    beta = 1.0 - alpha
    gamma = 0.0
    
    output = cv2.addWeighted(pred_side_1, alpha, pred_side_2, beta, gamma)
    
    return output



crop1 = segment_cleaned_skin[0][row_1 : row_2 + 1, col_1 : col_2 + 1, :]
crop2 = segment_cleaned_skin[5][row_1 : row_2 + 1, col_1 : col_2 + 1, :]

output = combine(crop1, crop2)

plt.figure(figsize=(4.4,4.4))
plt.imshow(cv2.merge([output[:, :, 2],
                      output[:, :, 1],
                      output[:, :, 0]]))
plt.title('output')








#
#
#crop1 = segment_cleaned_skin[0][row_1 : row_2 + 1, col_1 : col_2 + 1, :]
#crop2 = segment_cleaned_skin[5][row_1 : row_2 + 1, col_1 : col_2 + 1, :]
#
#plt.figure(figsize=(10,10))
#
#plt.subplot(141)
#plt.imshow(cv2.merge([crop1[:, :, 2], crop1[:, :, 1], crop1[:, :, 0]]))
#plt.title('crop1')
#
#plt.subplot(142)
#plt.imshow(crop1[:, :, 0])
#plt.title('crop1[:, :, 0]')
#
#plt.subplot(143)
#plt.imshow(crop1[:, :, 1])
#plt.title('crop1[:, :, 1]')
#
#plt.subplot(144)
#plt.imshow(crop1[:, :, 2])
#plt.title('crop1[:, :, 2]')
#
#
#
#mask1 = np.any(crop1, axis=2)
#plt.figure(figsize=(4.4,4.4))
#plt.imshow(mask1)
#plt.title('mask1')
#
#
#
#plt.figure(figsize=(10,10))
#
#plt.subplot(141)
#plt.imshow(cv2.merge([crop2[:, :, 2], crop2[:, :, 1], crop2[:, :, 0]]))
#plt.title('crop2')
#
#plt.subplot(142)
#plt.imshow(crop2[:, :, 0])
#plt.title('crop2[:, :, 0]')
#
#plt.subplot(143)
#plt.imshow(crop2[:, :, 1])
#plt.title('crop2[:, :, 1]')
#
#plt.subplot(144)
#plt.imshow(crop2[:, :, 2])
#plt.title('crop2[:, :, 2]')
#
#plt.show()
#
#
#mask2 = np.any(crop2, axis=2)
#plt.figure(figsize=(4.4,4.4))
#plt.imshow(mask2)
#plt.title('mask2')
#
#
#
#
#intersection = np.logical_and(mask1, mask2)
#xor_mask1 = np.logical_xor(mask1, intersection)
#xor_mask2 = np.logical_xor(mask2, intersection)
#
#
#
#plt.figure(figsize=(7.5,7.5))
#
#plt.subplot(131)
#plt.imshow(xor_mask1)
#plt.title('xor_mask1')
#
#plt.subplot(132)
#plt.imshow(intersection)
#plt.title('intersection')
#
#plt.subplot(133)
#plt.imshow(xor_mask2)
#plt.title('xor_mask2')
#
#plt.show()
#
#
#
#pred_side_1 = np.copy(crop1)
#pred_side_2 = np.copy(crop2)
#
#np.copyto(pred_side_1, crop2,
#          where=np.stack([xor_mask2, xor_mask2, xor_mask2], axis=2))
#np.copyto(pred_side_2, crop1,
#          where=np.stack([xor_mask1, xor_mask1, xor_mask1], axis=2))
#
#
#plt.figure(figsize=(4.7, 4.7))
#
#plt.subplot(121)
#plt.imshow(cv2.merge([pred_side_1[:, :, 2],
#                      pred_side_1[:, :, 1],
#                      pred_side_1[:, :, 0]]))
#plt.title('pred_side_1')
#
#plt.subplot(122)
#plt.imshow(cv2.merge([pred_side_2[:, :, 2],
#                      pred_side_2[:, :, 1],
#                      pred_side_2[:, :, 0]]))
#plt.title('pred_side_2')
#
#plt.show()
#
#
#alpha = 0.5
#beta = 1.0 - alpha
#gamma = 0.0
#
#output = cv2.addWeighted(pred_side_1, alpha, pred_side_2, beta, gamma)
#
#plt.figure(figsize=(4.4,4.4))
#plt.imshow(cv2.merge([output[:, :, 2],
#                      output[:, :, 1],
#                      output[:, :, 0]]))
#plt.title('output')
#
#
