# -*- coding: utf-8 -*-
"""
Created on Thu Feb 15 19:02:25 2018

@author: Callie Darsey

I want to demo hand and forearm exemplars.
"""

import pickle
import numpy as np
import cv2
import skin_detector_01 as skin_detector
from matplotlib import pyplot as plt
import fns_investigating_optical_flow_01 as fns
import overlay_01 as overlay
import labeling_image_components_01 as labeling
import Adjustable_BB_02 as Adjustable_BB

        

# video path
paths_specific = ['/STI WA Apr25 A/STI WA Apr25 AMVI_0068_trans/',
                  'STI Polk Mar02 E/00005_trans/',
                  'STI Polk Apr13 E/MVI_0044_trans/',
                  'STI Polk Mar02 B/00006_trans/',
                  'STI WA Mar28 C/MVI_0013_trans/',
                  'STI WA May06 Polk B/MVI_0091_trans/',
                  'STI Polk Feb16 C/00054_trans/',
                  'STI Polk May04 F/MVI_0079_trans/',
                  'STI WA Apr18 D/MVI_0056_trans/',
                  'STI WA Feb28 xtraB/00011_trans/',
                  'STI Polk Apr20 C/MVI_0053_trans/',
                  'STI WA Apr18 B/MVI_0029_trans/',
                  'STI WA Feb28 C/00089_trans/']
paths_specific_subset = ['STI WA Apr18 D/MVI_0056_trans/',]

video_names = ['STI WA Apr25 AMVI_0068_trans__860_910.mp4',
               '00005_trans__605_628.mp4',
               'MVI_0044_trans__350_365.mp4',
               '00006_trans__567_600.mp4',
               'MVI_0013_trans__110_140.mp4',
               'MVI_0091_trans__60_85.mp4',
               '00054_trans__452_505.mp4',
               'MVI_0079_trans__390_415.mp4',
               'MVI_0056_trans__205_240.mp4',
               '00011_trans__290_335.mp4',
               'MVI_0053_trans__50_72.mp4',
               'MVI_0029_trans__75_125.mp4',
               '00089_trans__110_165.mp4']
video_names_subset = ['MVI_0056_trans__205_240.mp4']

frames_target = [[ 260,  748, 1200, 1480, 1648, 1660, 1780],
                 [  78,  164,  190,  202,  206,  322,  406,  442,  508,  554],
                 [  92,  248,  344,  404,  480,  544,  784],
                 [  84,  170,  316,  408,  500,  792,  870],
                 [   4,  272,  316,  620,  704,  940, 1140, 1260],
                 [  40,  212,  396,  480,  620,  792,  880],
                 [ 122,  360,  478,  632,  876,  906,  938, 1144, 1164, 1196],
                 [   0,  144,  688,  964],
                 [  76,  126,  814],
                 [ 134,  190,  202,  770,  778,  908, 1110],
                 [  76,  736,  800,  860, 1132, 1264],
                 [ 172,  324,  472,  596, 1136, 1720, 2000, 2128, 2396, 2576],
                 [  16,   22,  462,  478,  560,  712,  776,  784,  836, 1066, 1238]]

path_common = './video_copies_clips_track/copies_and_clips/'

# window for displaying window
display_title = "title"
move_window = [0, -60]
cv2.namedWindow(display_title, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
cv2.moveWindow(display_title, move_window[0], move_window[1])

escape = False

for path_specific, video_name, frame_list in zip(paths_specific,
                                                 video_names,
                                                 frames_target):
    
    if escape == True:
        
        cv2.destroyAllWindows()
        
        break
    
    for target_frame in frame_list:
        
        if escape == True:
        
            cv2.destroyAllWindows()
            
            break
        
        print('target frame', target_frame)
    
        # pickle
        pickle_path = path_common + path_specific + video_name[0:-4] + \
                      '__' + str(target_frame) + '.data'
                    
        with open(pickle_path, 'rb') as f:
            content = pickle.load(f)
            
        if len(content) == 2:
            frame, flow = content
            
            # frame copy to have same variable as other case
            frame_copy = np.copy(frame)
            
        elif len(content) == 3:
            frame, flow, boxes = content
            
            # copy frame so we don't draw rectangles in the original
            frame_copy = np.copy(frame)
            
            for points in boxes:
                
                cv2.rectangle(frame_copy, tuple(points[0:2]),
                              tuple(points[2:]), (0, 255, 200), 1)
        
        # displaying window
        cv2.imshow(display_title, frame_copy)
        
        k = cv2.waitKey(0)
        
        # escape
        if k == 27:
            
            escape = True
            
            cv2.destroyAllWindows()
            
            break
else:
    cv2.destroyAllWindows()
    