# -*- coding: utf-8 -*-
"""
Created on Tue Jan 23 12:25:55 2018

@author: Callie Darsey

I want to see how many video frames I can save in memory before it crashes.
"""


import numpy as np
import cv2
from matplotlib import pyplot as plt
import fns_investigating_optical_flow_01 as fns


# video path
video_path = './video_copies_clips_track/copies_and_clips/' + \
             'STI Polk Mar02 B/00006_trans.mp4'
             
# process the mp4 video
cap = cv2.VideoCapture(video_path)

num_frames = cap.get(cv2.CAP_PROP_FRAME_COUNT)
fps = cap.get(cv2. CAP_PROP_FPS )
print('number of frames:', num_frames, ', frames per second:', fps)

collect_frames = []

# prep window
title = 'display window'
cv2.namedWindow(title, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)

fcount = 0

while(cap.isOpened()):

    success_flag, frame2_full = cap.read()

    if (success_flag):
        
        fcount = fcount + 1
        print(fcount)
        
        collect_frames.append(frame2_full)
        
        cv2.imshow(title, frame2_full)
    
        # Esc key press will escape
        k = cv2.waitKey(1) & 0xff
        if k == 27:
    
            # release capture
            cap.release()
    
            # close all the OpenCV windows
            cv2.destroyAllWindows()
            
            break 
    else:  
        print("no more frames in this capture")
        
        # release capture
        cap.release()

        # close all the OpenCV windows
        cv2.destroyAllWindows()
        
        break 
   
else:
    print('cap not open')
        
    # release capture
    cap.release()

    # close all the OpenCV windows
    cv2.destroyAllWindows()
