# -*- coding: utf-8 -*-
"""
Created on Sat Apr 14 22:03:22 2018

@author: Callie Darsey

save feature vectors for different patch sizes using the knn classification
image to force the patches to be the misclassified patches
"""

import os
import pickle
import patches_01 as patches
import numpy as np
import cv2


path = './video_copies_clips_track/ROI_masks_patch_detection/'
#roi_filenames = [f for f in os.listdir(path) if os.path.isfile(path + f)]
#roi_filenames = [\
#'STI Polk Apr13 E-MVI_0044_trans__350_365_0416.data',
#'STI Polk Apr20 C-MVI_0053_trans__50_72_0080.data',
##'STI Polk Mar30 F-MVI_0025_trans__250_280_0388.data',
#'STI Polk May04 F-MVI_0079_trans__390_415_0148.data',
##'STI WA Apr11 A-MVI_0023_trans__100_200_2132.data',
#'STI WA Apr18 B-MVI_0029_trans__75_125_0212.data',
##'STI WA Apr25 A-STI WA Apr25 AMVI_0068_trans__860_910_1772.data',
#'STI WA Mar28 C-MVI_0013_trans__110_140_0768.data',
##'STI WA May06 C-MVI_0095_trans__0_100_0540.data',
#'STI WA May06 Polk B-MVI_0091_trans__60_85_0480.data',
##'STI WA May06 Polk C-MVI_0087_trans__600_700_1224.data',
#'STI WA May09 A-MVI_0110_trans__100_200_2384.data',
##'STI WA May09 B-MVI_0006_trans__600_700_0496.data',
#]

roi_filenames = [\
'STI Polk Apr13 E-MVI_0044_trans__350_365_0416.data',
'STI Polk Apr20 C-MVI_0053_trans__50_72_0080.data',
'STI Polk Mar30 F-MVI_0025_trans__250_280_0388.data',
'STI Polk May04 F-MVI_0079_trans__390_415_0148.data',
'STI WA Apr11 A-MVI_0023_trans__100_200_2132.data',
'STI WA Apr18 B-MVI_0029_trans__75_125_0212.data',
'STI WA Apr25 A-STI WA Apr25 AMVI_0068_trans__860_910_1772.data',
'STI WA Mar28 C-MVI_0013_trans__110_140_0768.data',
'STI WA May06 C-MVI_0095_trans__0_100_0540.data',
'STI WA May06 Polk B-MVI_0091_trans__60_85_0480.data',
'STI WA May06 Polk C-MVI_0087_trans__600_700_1224.data',
'STI WA May09 A-MVI_0110_trans__100_200_2384.data',
'STI WA May09 B-MVI_0006_trans__600_700_0496.data',
]

# make the review folder
save = path + "block_feature_vectors/"
if not os.path.isdir(save):
    os.mkdir(save)

# number of neighbors
k = 5

print('Number of frames: {}\n'.format(len(roi_filenames)))

#for block_dim in [2, 3, 4, 5]:
#for block_dim in [6, 7, 8]:
for block_dim in [9, 10, 11]:
    
    print('block dimension ({:d}, {:d})'.format(block_dim, block_dim))
    
    hand_feature_vectors_collect = []
    non_skin_feature_vectors_collect = []
    
    for roi_filename in roi_filenames:
        
        print(roi_filename)
        
        # get the roi masks
        with open(path + roi_filename, 'rb') as f:
            
            roi_masks, frame = pickle.load(f)
        
        
#        # get classifed as skin mask
#        classified_frame = cv2.imread(path + \
#            'classified_witheld/classified_patch_skin_mask_' + \
#            roi_filename[0:-5] + \
#            'knn_{:03}_block_dim_{:02d}.png'.format(k, block_dim))
#        
#        classified_skin_mask = (np.sum(classified_frame.astype(np.float), axis=2) > 0).astype(np.uint8)
        
        # from the ROI info, collect the hand mask and non-skin mask
        hand_mask_collect = []
        non_skin_mask_collect = []
        
        for key in roi_masks.keys():
            
            if 'hand' in key:
                
                hand_mask_collect.append(roi_masks[key])
                
            elif 'non_skin' in key:
#                non_skin_mask_collect.append(roi_masks[key] * \
#                                             classified_skin_mask)
                non_skin_mask_collect.append(roi_masks[key])
                
        hand_mask = np.any(hand_mask_collect, axis=0)       
        non_skin_mask = np.any(non_skin_mask_collect, axis=0)
        
#        # AND the ROI non-skin mask with the classified as skin mask
#        non_skin_mask = np.all([classified_skin_mask, non_skin_mask], axis=0)
        
        hand_feature_vectors = \
            patches.get_valid_blocks_as_feature_vectors(frame, hand_mask,
                                                        block_dim)
    
        non_skin_feature_vectors = \
            patches.get_valid_blocks_as_feature_vectors(frame, non_skin_mask,
                                                        block_dim)
        print('Number of hand feature vector:     {}'.format(\
              hand_feature_vectors.shape[0]))
        print('Number of non-skin feature vector: {}\n'.format(\
              non_skin_feature_vectors.shape[0]))
    
        with open(save+roi_filename[0:-5] + \
                  '_block_dim_{:02d}.data'.format(block_dim), 'wb') as f:
            
            pickle.dump((hand_feature_vectors, non_skin_feature_vectors), f)
