# -*- coding: utf-8 -*-
"""
Created on Fri May 11 16:44:37 2018

@author: Callie Darsey

first_patch_LOO_attempt_01
"""

import pickle
import numpy as np
import sklearn.ensemble as ske
import sklearn.metrics as skmet
import sklearn.neighbors as skn
import sklearn.linear_model as sklm
import sklearn.model_selection as sklms
import matplotlib.pyplot as plt
import cv2
import sklearn.tree as sklt

def merge_my_dicts(d_list):
    '''
    '''
    my_merged_dict = {}
    
    for key in d_list[0].keys():
        print(key)
        
        for d in d_list[1:]:
            assert key in d.keys()
            assert np.count_nonzero([d_list[0][key][0] != d[key][0]]) == 0
            assert d_list[0][key][1] == d[key][1]
            
        val = [d_list[0][key][0], d_list[0][key][1]]
        
        features = []
        
        for d in d_list:
            
            features = features + [d[key][2]]
            
        val = val + [np.hstack(features)]

        my_merged_dict[key] = val
        
    return my_merged_dict
            
e1 = cv2.getTickCount()

upper = './wheeler/dataset/'
tags = ['patches_labels_and_subsetagain_feature_flow_sum_all_mag_Bins_32___',
        'patches_labels_and_subsetagain_feature_flow_mag_sum_all_Bins_32___',
        'patches_labels_and_subset_feature_watershed_skin_bool_Bins_32___',
        'patches_labels_and_subset_feature_skin_bool_Bins_32___',
        'patches_labels_and_subset_feature_skin_count_Bins_32___']

ftypes = ['flow sum mag',
          'flow mag sum',
          'watershed skin bool',
          'skin bool',
          'skin count']

clip_infos = [[]] * 15

for tag in tags:
    
    clip_info = [\
    upper + 'part1/MVI_0069_trans/' + tag + 'MVI_0069_trans__0_100.data',
    upper + 'STI_Polk_Apr13_C/MVI_0039_trans/' + tag + 'MVI_0039_trans__460_563.data',
    upper + 'STI_Polk_Apr27_A/MVI_0073_trans/' + tag + 'MVI_0073_trans__0_100.data',
    upper + 'STI_Polk_Apr27_D/MVI_0063_trans/' + tag + 'MVI_0074_trans__240_342.data',
    upper + 'STI_Polk_May04_A/MVI_0087_trans/' + tag + 'MVI_0087_trans__579_680.data',
    upper + 'STI_Polk_May11_C/MVI_0108_trans/' + tag + 'MVI_0108_trans__0_42.data',
    upper + 'STI_WA_Apr11_extra_B/MVI_0036_trans/' + tag + 'MVI_0036_trans__870_912.data',
    upper + 'STI_WA_Jun12_B/MVI_0018_trans/' + tag + 'MVI_0018_trans__910_954.data',
    upper + 'STI_WA_Jun14_Lb/MVI_0070_trans/' + tag + 'MVI_0070_trans__670_712.data',
    upper + 'STI_WA_Jun20_CT/MVI_0029_trans/' + tag + 'MVI_0029_trans__515_557.data',
    upper + 'STI_WA_Jun22_De/MVI_0118_trans/' + tag + 'MVI_0118_trans__100_142.data',
    upper + 'STI_WA_Jun23_Da/MVI_0112_trans/' + tag + 'MVI_0112_trans__15_57.data',
    upper + 'STI_WA_May02_B/MVI_0053_trans/' + tag + 'MVI_0053_trans__0_100.data',
    upper + 'STI_WA_May02_C/MVI_0074_trans/' + tag + 'MVI_0074_trans__60_102.data',
    upper + 'STI_WA_May09_A/MVI_0109_trans/' + tag + 'MVI_0109_trans__0_42.data']
    
    for i, data in enumerate(clip_info):
        
        clip_infos[i] = clip_infos[i] + [data]


segment = 45

# holds head and hand feature vectors per clip
exemplar_vectors_per_clip = []
non_exemplar_feature_vectors_per_clip_drawn = []
non_exemplar_feature_vectors_per_clip = []

for clip in clip_infos:
    
    patches_infos = []
    
    for data in clip:
        
        with open(data, 'rb') as f:
            
            patches_info = pickle.load(f)
            
        patches_infos.append(patches_info)
    
    patches_info_merged = merge_my_dicts(patches_infos)
    
    exemplar_clip = []
    non_exemplar_drawn_clip = []
    non_exemplar_clip = []
        
    for info in patches_info_merged.values():
        
        patches, tags, feature = info[0], info[1], info[2]
        
        tags_ar = np.array(tags)
        
        
        # group according to tags
        exemplar_indices = np.where(np.any([tags_ar == 'predominately head',
                                            tags_ar == 'predominately both',
                                            tags_ar == 'predominately hand'],
                                            axis=0))[0]
        
        non_exemplar_indices = \
            np.where(tags_ar == 'predominately non-exemplar')[0]
        
        # features
        if len(exemplar_indices) > 0:
            
            exemplar_clip.append(feature[exemplar_indices, :])
            
        if len(non_exemplar_indices) > 0:

            non_exemplar_clip.append(feature[non_exemplar_indices, :])            
            
            np.random.shuffle(non_exemplar_indices)
            
            non_exemplar_drawn_clip.append(\
                feature[non_exemplar_indices[0:len(exemplar_indices)], :])
            
    # stack for clip
    exemplar_clip = np.vstack(exemplar_clip)
    non_exemplar_drawn_clip = np.vstack(non_exemplar_drawn_clip)
    non_exemplar_clip = np.vstack(non_exemplar_clip)
    
    # collect per clip
    exemplar_vectors_per_clip.append(exemplar_clip)
    non_exemplar_feature_vectors_per_clip_drawn.append(non_exemplar_drawn_clip)
    non_exemplar_feature_vectors_per_clip.append(non_exemplar_clip)

# boxplots
exemplars = np.vstack(exemplar_vectors_per_clip)
non_exemplars = np.vstack(non_exemplar_feature_vectors_per_clip)

for i, ftype in enumerate(ftypes):

    plt.figure(figsize=(10, 9))
    plt.subplot(121)
    e_bp = plt.boxplot(exemplars[:, i])
    plt.title('exemplars - ' + ftype)
    #plt.ylim(-500, 300000)
    
    plt.subplot(122)
    ne_bp = plt.boxplot(non_exemplars[:, i])
    plt.title('non-exemplars - ' + ftype)
    #plt.ylim(-500, 300000)
    plt.show()


indices = np.arange(len(clip_info))

accuracy_collect = []
precision_collect = []
recall_collect = []
f1_collect = []

print('')

save_grid_search = []

for i in indices:
    
    val_test_index = i
    train_indices = np.where(indices != i)[0]
    
    train_exemplar = exemplar_vectors_per_clip.copy()
    train_non_exemplar = non_exemplar_feature_vectors_per_clip.copy()
    
    val_test_exemplar = train_exemplar.pop(i)
    train_non_exemplar.pop(i)
    val_test_non_exemplar = non_exemplar_feature_vectors_per_clip[i]
    
    # stack    
    train_exemplar = np.vstack(train_exemplar)
    train_non_exemplar = np.vstack(train_non_exemplar)
    
    X = np.vstack([train_non_exemplar, train_exemplar])
    
    print('X.shape', X.shape, ' (',
          'train_non_exemplar.shape', train_non_exemplar.shape,                       
          'train_exemplar.shape', train_exemplar.shape, ')')
        
    X_LOO = np.vstack([val_test_non_exemplar, val_test_exemplar])
    
    # 0 for non-exemplar, 1 for exemplar
    y_train = np.hstack([np.zeros(len(train_non_exemplar)),
                         np.ones(len(train_exemplar))])
            
    y_val = np.hstack([np.zeros(len(val_test_non_exemplar)),
                       np.ones(len(val_test_exemplar))])

    # random forest classifier
    n_estimators = 50
    
    '''
    Defaults:
    
    n_estimators=10,
    criterion='gini',
    max_depth=None,
    max_features='auto',
    max_leaf_nodes=None,    
    min_samples_split=2,
    min_samples_leaf=1,
    min_weight_fraction_leaf=0.0,
    min_impurity_split=1e-07,
    bootstrap=True,
    oob_score=False,
    n_jobs=1,
    random_state=None,
    verbose=0,
    warm_start=False,
    class_weight=None   
    '''
    
    param_distributions = {'n_estimators' : [50, 100],
                           'criterion' : ['gini'],
                           
                           'max_depth' : [1, 3],
                           'max_features' : [1, 2],
                           'max_leaf_nodes' : [2, 5],
              
                           'min_samples_split' : [2, 100],
                           'min_samples_leaf' : [1, 100],
                           'min_weight_fraction_leaf' : [0.0],
                           'min_impurity_split' : [1e-7, 1e-4],
                           'bootstrap' : [True],
                           'oob_score' : [False],
                           'n_jobs' : [-1],
                           'random_state' : [None],
                           'verbose' : [1],
                           'warm_start' : [False],
                           'class_weight' : [None, 'balanced',
                                             'balanced_subsample']}  
    ei = cv2.getTickCount()
    rf_clf = ske.RandomForestClassifier()
    gs_rf_clf = sklms.GridSearchCV(rf_clf, param_distributions,
        scoring=skmet.make_scorer(skmet.recall_score,pos_label=1), verbose=4)
    
#    knn_clf = skn.KNeighborsClassifier(51)
    
#    knn_clf = sklm.LogisticRegression()
        
    # train
    gs_rf_clf.fit(X, y_train)
    
    save_grid_search.append(gs_rf_clf)
    
    # leave-one-out test
    print('X_LOO.shape', X_LOO.shape, ' (',
          'val_test_non_exemplar.shape', val_test_non_exemplar.shape,
          'val_test_exemplar.shape', val_test_exemplar.shape, ')')
    
    y_predicted = gs_rf_clf.predict(X_LOO)
#    y_predicted = np.zeros_like(y_val)
#    y_predicted[np.where(X_LOO > 0)[0]] = 1 

    # report
    accuracy = skmet.accuracy_score(y_val, y_predicted)
    precision = skmet.precision_score(y_val, y_predicted, labels=[0, 1],
                                      average=None)
    recall = skmet.recall_score(y_val, y_predicted, labels=[0, 1],
                                average=None)
    f1 = skmet.f1_score(y_val, y_predicted, labels=[0, 1], average=None)
    
    accuracy_collect.append(accuracy)
    precision_collect.append(precision)
    recall_collect.append(recall)
    f1_collect.append(f1)
    
    header_row    = '           non-exemplar     exemplar '
    precision_row = 'Precision  {:12.3f}  {:12.3f}'
    recall_row    = 'Recall     {:12.3f}  {:12.3f}'
    f1_row        = 'F1 score   {:12.3f}  {:12.3f}'
    accuracy_row  = 'Accuracy  {:12.3f}'
    
    print(accuracy_row.format(accuracy))
    print('confusion matrix:\n', skmet.confusion_matrix(y_val, y_predicted))
    print(header_row)
    print(precision_row.format(precision[0], precision[1]))
    print(recall_row.format(recall[0], recall[1]))
    print(f1_row.format(f1[0], f1[1]))
    
    ee = cv2.getTickCount()
    print("Per LOO execution {:.2f} seconds".format(\
        (ee - ei) / cv2.getTickFrequency()))

print('tag:', tag)
print('n_estimators:', n_estimators)
print(ftype)


accuracy_collect = np.vstack(accuracy_collect)
precision_collect = np.vstack(precision_collect)
recall_collect = np.vstack(recall_collect)
f1_collect = np.vstack(f1_collect)


accuracy_row  = 'Accuracy'
minimum_row   = '          Minimum    {:12.3f}'
median_row    = '          Median     {:12.3f}'
mean_row      = '          Mean       {:12.3f}'
maximum_row   = '          Maximum    {:12.3f}'

print(accuracy_row)
print(minimum_row.format(np.min(accuracy_collect)))
print(median_row.format(np.median(accuracy_collect)))
print(mean_row.format(np.mean(accuracy_collect)))
print(maximum_row.format(np.max(accuracy_collect)))

precision_row = 'Precision          non-exemplar     exemplar '
recall_row    = 'Recall             non-exemplar     exemplar '
minimum_row   = '          Minimum  {:12.3f}  {:12.3f}'
median_row    = '          Median   {:12.3f}  {:12.3f}'
mean_row      = '          Mean     {:12.3f}  {:12.3f}'
maximum_row   = '          Maximum  {:12.3f}  {:12.3f}'

print(precision_row)
print(minimum_row.format(np.min(precision_collect[:, 0]), 
                         np.min(precision_collect[:, 1])))
print(median_row.format(np.median(precision_collect[:, 0]),
                        np.median(precision_collect[:, 1])))
print(mean_row.format(np.mean(precision_collect[:, 0]),
                      np.mean(precision_collect[:, 1])))
print(maximum_row.format(np.max(precision_collect[:, 0]),
                         np.max(precision_collect[:, 1])))

print(recall_row)
print(minimum_row.format(np.min(recall_collect[:, 0]), 
                         np.min(recall_collect[:, 1])))
print(median_row.format(np.median(recall_collect[:, 0]),
                        np.median(recall_collect[:, 1])))
print(mean_row.format(np.mean(recall_collect[:, 0]),
                      np.mean(recall_collect[:, 1])))
print(maximum_row.format(np.max(recall_collect[:, 0]),
                         np.max(recall_collect[:, 1])))

e2 = cv2.getTickCount()
print("Total execution {:.2f} seconds".format(\
    (e2 - e1) / cv2.getTickFrequency()))