# -*- coding: utf-8 -*-
"""
Created on Sat May  5 17:08:13 2018

@author: Callie Darsey

flow_mag_stat_info_01
"""

import os
import pickle
import numpy as np

folder = os.path.join('.', 'wheeler', 'dataset')
data_files = []
for sub_folder in os.listdir(folder):
    
    if os.path.isdir(os.path.join(folder, sub_folder)):
        
        for inner_folder in os.listdir(os.path.join(folder, sub_folder)):
            
            path = os.path.join(folder, sub_folder, inner_folder)
            
            if os.path.isdir(path):
                
                for content in os.listdir(path):
                    
                    data_file = os.path.join(path, content)
                                        
                    if os.path.isfile(data_file) and \
                        data_file[-19:] == '.flow_mag_info.data':
                            
                            data_files.append(data_file)
mins_string = ''
medians_string = ''
means_string = ''
maxs_string = ''

mins_collect = []
medians_collect = []
means_collect = []
maxs_collect = []
                            
for data_file in data_files:                            
    with open(data_file, 'rb') as f:
        mins, medians, means, maxs = pickle.load(f)
        
    stats = 'minimum: {:9.6f},  ' + \
            'median: {:9.6f},  ' + \
            'mean: {:9.6f},  ' + \
            'maximum: {:10.6f}'

    mins_string = mins_string + stats.format(np.min(mins),
                                             np.median(mins),
                                             np.mean(mins),
                                             np.max(mins)) + '\n'
                                             
    medians_string = medians_string + stats.format(np.min(medians),
                                             np.median(medians),
                                             np.mean(medians),
                                             np.max(medians)) + '\n'
                                                   
    means_string = means_string + stats.format(np.min(means),
                                             np.median(means),
                                             np.mean(means),
                                             np.max(means)) + '\n'
                                               
    maxs_string = maxs_string + stats.format(np.min(maxs),
                                             np.median(maxs),
                                             np.mean(maxs),
                                             np.max(maxs)) + '\n'
                                                     
    mins_collect.append(mins)
    medians_collect.append(medians)
    means_collect.append(means)
    maxs_collect.append(maxs)
                           
print('Stats on Minimuns\n'); print(mins_string)
print('Stats on Medians\n'); print(medians_string)
print('Stats on Means\n'); print(means_string)
print('Stats on Maximums\n'); print(maxs_string)

all_mins = np.hstack(mins_collect)
all_medians = np.hstack(medians_collect)
all_means = np.hstack(means_collect)
all_maxs = np.hstack(maxs_collect)

print('Stats on All Frame Minimums')
print(stats.format(np.min(all_mins), np.median(all_mins),
                   np.mean(all_mins), np.max(all_mins)) + '\n')
print('Stats on All Frame Medians')
print(stats.format(np.min(all_medians), np.median(all_medians),
                   np.mean(all_medians), np.max(all_medians)) + '\n')
print('Stats on All Frame Means')
print(stats.format(np.min(all_means), np.median(all_means),
                   np.mean(all_means), np.max(all_means)) + '\n')
print('Stats on All Frame Maximums')
print(stats.format(np.min(all_maxs), np.median(all_maxs),
                   np.mean(all_maxs), np.max(all_maxs)) + '\n')

