# -*- coding: utf-8 -*-
"""
Created on Wed Nov 15 19:57:19 2017

@author: Callie Darsey cj.darsey@gmail.com

This script creates two .json files
    ftp_loc_mp4.json         - Location and filename of .mp4 videos on the ftp
    ftp_loc_mp4_visited.json - Will hold location and filename of .mp4 videos
                               on the ftp which I've looked at
                               
    For starts, only looking at Spring 2017.
"""

from ftplib import FTP_TLS
import os
import json

ftp_loc_mp4 = './video_copies_clips_track/track_aolme1_entry/ftp_loc_mp4.json'
ftp_loc_mp4_visited = \
    './video_copies_clips_track/track_aolme1_entry/ftp_loc_mp4_visited.json'

common = '/var/www/html/aolme/vid/aolme1'

'''
zip(['2017', '2018', 'ftp'], [common, common, common])
'''

for key, directory in zip(['ftp'], [common]):
    
    print('', key, '')
    
    visited_loc_dic = {}
    
    if os.path.isfile(ftp_loc_mp4_visited):
        with open(ftp_loc_mp4_visited, 'r') as f:
            visited_loc_dic = json.load(f)
            
    if key not in visited_loc_dic.keys():
        visited_loc_dic[key] = []
        
    loc_dic = {}

    if os.path.isfile(ftp_loc_mp4):
        with open(ftp_loc_mp4, 'r') as f:
            loc_dic = json.load(f)
    
    def fill_dict(key, dictionary, directory):
        
        ftp = FTP_TLS("129.24.28.223")
        print("Welcome: ", ftp.getwelcome())
        ftp.auth()
        ftp.prot_p()
        ftp.login(user='cdarsey', passwd='xyz123693')
        
        store_ftp_loc_mp4 = []
        
        def go_down(directory):
            print(directory)
            ftp.cwd(directory)
            
            entries = []
            def addElements(data):
                entries.append(data)
            
            ftp.retrlines('NLST', addElements)
        
            for entry in entries:
                try:
                    go_down(directory+'/'+entry)
                except:
                    if entry[-4:] == '.mp4':
                        print(directory+'/'+entry)
                        store_ftp_loc_mp4.append(directory+'/'+entry)
        
        go_down(directory)
        
        ftp.quit() 
        dictionary[key] = store_ftp_loc_mp4
        
        return dictionary
                    
    loc_dic = fill_dict(key, loc_dic, directory+'/'+key)

with open(ftp_loc_mp4, 'w') as f:
    json.dump(loc_dic, f)
    
with open(ftp_loc_mp4_visited, 'w') as f:
    json.dump(visited_loc_dic, f)
