# -*- coding: utf-8 -*-
"""
Created on Thu Feb 15 06:45:32 2018

@author: Callie Darsey

I need to be able to make boxes in an image. I want boxes around the hand
and forearm.
"""
import pickle
import numpy as np
import cv2
import skin_detector_01 as skin_detector
from matplotlib import pyplot as plt
import fns_investigating_optical_flow_01 as fns
import overlay_01 as overlay
import labeling_image_components_01 as labeling
import Adjustable_BB_02 as Adjustable_BB

        

# video path
paths_specific = ['/STI WA Apr25 A/STI WA Apr25 AMVI_0068_trans/',
                  'STI Polk Mar02 E/00005_trans/',
                  'STI Polk Apr13 E/MVI_0044_trans/',
                  'STI Polk Mar02 B/00006_trans/',
                  'STI WA Mar28 C/MVI_0013_trans/',
                  'STI WA May06 Polk B/MVI_0091_trans/',
                  'STI Polk Feb16 C/00054_trans/',
                  'STI Polk May04 F/MVI_0079_trans/',
                  'STI WA Apr18 D/MVI_0056_trans/',
                  'STI WA Feb28 xtraB/00011_trans/',
                  'STI Polk Apr20 C/MVI_0053_trans/',
                  'STI WA Apr18 B/MVI_0029_trans/',
                  'STI WA Feb28 C/00089_trans/']
paths_specific_subset = ['STI WA Apr18 D/MVI_0056_trans/',]

video_names = ['STI WA Apr25 AMVI_0068_trans__860_910.mp4',
               '00005_trans__605_628.mp4',
               'MVI_0044_trans__350_365.mp4',
               '00006_trans__567_600.mp4',
               'MVI_0013_trans__110_140.mp4',
               'MVI_0091_trans__60_85.mp4',
               '00054_trans__452_505.mp4',
               'MVI_0079_trans__390_415.mp4',
               'MVI_0056_trans__205_240.mp4',
               '00011_trans__290_335.mp4',
               'MVI_0053_trans__50_72.mp4',
               'MVI_0029_trans__75_125.mp4',
               '00089_trans__110_165.mp4']
video_names_subset = ['MVI_0056_trans__205_240.mp4']

frames_target = [[ 260,  748, 1200, 1480, 1648, 1660, 1780],
                 [  78,  164,  190,  202,  206,  322,  406,  442,  508,  554],
                 [  92,  248,  344,  404,  480,  544,  784],
                 [  84,  170,  316,  408,  500,  792,  870],
                 [   4,  272,  316,  620,  704,  940, 1140, 1260],
                 [  40,  212,  396,  480,  620,  792,  880],
                 [ 122,  360,  478,  632,  876,  906,  938, 1144, 1164, 1196],
                 [   0,  144,  688,  964],
                 [  76,  126,  814],
                 [ 134,  190,  202,  770,  778,  908, 1110],
                 [  76,  736,  800,  860, 1132, 1264],
                 [ 172,  324,  472,  596, 1136, 1720, 2000, 2128, 2396, 2576],
                 [  16,   22,  462,  478,  560,  712,  776,  784,  836, 1066, 1238]]

frames_target_subset1 = [[1200],
                        [322],
                        [344, 404],
                        [792],
                        [940],
                        [792],
                        [1144],
                        [144],
                        [126],
                        [778],
                        [860],
                        [1720],
                        [712]]

frames_target_subset2 = [[ 260],
                        [ 190,],
                        [  92, 784],
                        [ 500],
                        [ 620],
                        [ 480],
                        [1196],
                        [ 964],
                        [  76],
                        [1110],
                        [ 800],
                        [1136],
                        [478]]

frames_target_subset2 = [[814]]

path_common = './video_copies_clips_track/copies_and_clips/'


escape = False

for path_specific, video_name, frame_list in zip(paths_specific,
                                                 video_names,
                                                 frames_target):
    
    if escape == True:
        
        cv2.destroyAllWindows()
        
        break
    
    for target_frame in frame_list:
        
        if escape == True:
        
            cv2.destroyAllWindows()
            
            break
        
        print('target frame', target_frame)
    
        # pickle
        pickle_path = path_common + path_specific + video_name[0:-4] + \
                      '__' + str(target_frame) + '.data'
                    
        with open(pickle_path, 'rb') as f:
            frame, flow = pickle.load(f)
            
        # window for displaying window
        display_title = "'n' to do new ROI, "  
        move_window = [0, -60]
        cv2.namedWindow(display_title, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
        cv2.moveWindow(display_title, move_window[0], move_window[1])
        
        # point1_x, point1_y, point2_x, point2_y
        boxes = None
        
        # copy frame so we don't draw rectangles in the original
        frame_copy = np.copy(frame)
        
        while (True):
                        
            cv2.imshow(display_title, frame_copy)
        
            k = cv2.waitKey(0)
            
            # escape
            if k == 27:
                
                escape = True
                
                cv2.destroyAllWindows()
                
                break
                
            # space
            elif k == 32:
                
                # pickle because we are continuing to the frame
                print(pickle_path)
                
                with open(pickle_path, 'wb') as f:
                    pickle.dump((frame, flow, boxes), f)
                            
                break

            # n
            elif k == 110:

                wnd_name = 'make ROI, press escape or space to leave ROI mode'
                cv2.namedWindow(wnd_name, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
                cv2.moveWindow(wnd_name, move_window[0], move_window[1])
                # x, y, width, height
                
                x, y, width, height = cv2.selectROI(wnd_name, frame,
                                                    False, False)
                cv2.destroyWindow(wnd_name)
                
                # allow for adjusting bounding box 

                prompt = 'Are ready to leave?\n\n\n' + \
                         'Yes to close adjustment window and save box.\n\n' + \
                         'No to continue adjusting.\n\n' + \
                         'Quit to close adjustment window without saving.\n\n'    
                abb = Adjustable_BB.AdjustableBB(prompt)
                
                wnd_abb = 'drag borders to adjust, click in box to leave'
                frame_canvas = np.copy(frame)
                point1 = (int(x + width - 1), int(y + height - 1))
                point2 = (int(x), int(y))
                
                abb.act(wnd_abb, frame_canvas, point1, point2, move_window)
                
                print('done with adjusting')
                
                # save and draw
                if abb.get_reply() == 'yes':
                    
                    points = abb.get_points()
                    
                    if boxes == None:
                        boxes = np.array([points])
                        
                    else:
                        boxes = np.vstack([boxes, points])
                        
                    
                        
                    frame_copy = cv2.rectangle(frame_copy, tuple(boxes[-1, 0:2]),
                                  tuple(boxes[-1, 2:]), (0, 255, 200), 1)


                
        else:
            
            escape == True
                
        
        
        
        
            
            
        