# -*- coding: utf-8 -*-
"""
Created on Mon Apr 30 13:56:03 2018

@author: Callie Darsey


getting the labels displayed

getting_exemplars_labels_displayed_01
"""



import numpy as np
import cv2
from matplotlib import pyplot as plt
import fns_investigating_optical_flow_01 as fns
import os
import overlay_01 as overlay
import Adjustable_BB_05 as Adjustable_BB
import datetime
import pickle
import sys


# video path
path_common = './video_copies_clips_track/copies_and_clips_wave_04/'


#path_specific = "part1/MVI_0069_trans/"
#video_name = "MVI_0069_trans__0_100.mp4"

#path_specific = "STI Polk Apr13 C/MVI_0039_trans/"
#video_name = "MVI_0039_trans__460_563.mp4"

#path_specific = "STI Polk Apr27 A/MVI_0073_trans/"
#video_name = "MVI_0073_trans__0_100.mp4"

#path_specific = "STI Polk Apr27 D/MVI_0063_trans/"
#video_name = "MVI_0074_trans__240_342.mp4"

#path_specific = "STI Polk May04 A/MVI_0087_trans/"
#video_name = "MVI_0087_trans__579_680.mp4"

#path_specific = "STI Polk May11 C/MVI_0108_trans/"
#video_name = "MVI_0108_trans__0_42.mp4"

#path_specific = "STI WA Apr11 extra B/MVI_0036_trans/"
#video_name = "MVI_0036_trans__870_912.mp4"

#path_specific = "STI WA Jun12 B/MVI_0018_trans/"
#video_name = "MVI_0018_trans__910_954.mp4"

#path_specific = "STI WA Jun14 Lb/MVI_0070_trans/"
#video_name = "MVI_0070_trans__670_712.mp4"

#path_specific = "STI WA Jun20 CT/MVI_0029_trans/"
#video_name = "MVI_0029_trans__515_557.mp4"

#path_specific = "STI WA Jun22 De/MVI_0118_trans/"
#video_name = "MVI_0118_trans__100_142.mp4"

#path_specific = "STI WA Jun23 Da/MVI_0112_trans/"
#video_name = "MVI_0112_trans__15_57.mp4"

#path_specific = "STI WA May02 B/MVI_0053_trans/"
#video_name = "MVI_0053_trans__0_100.mp4"

#path_specific = "STI WA May02 C/MVI_0074_trans/"
#video_name = "MVI_0074_trans__60_102.mp4"

path_specific = "STI WA May09 A/MVI_0109_trans/"
video_name = "MVI_0109_trans__0_42.mp4"



video_path = path_common + path_specific + video_name

'''
bool for whether the input video already has reduced frames
'''
reduced_frames = False
             

# Setting to play with

'''Resolution rescaling factor'''
scaleFactor = 0.67
#scaleFactor = 1.0

'''
normalization of optical flow by resolution scaling factor and 
number of frames advanced
'''
normalize_scale = False
normalize_frame_advance = False

''' wait to calculate optical flow and display '''
frame_wait = 0

'''
Optical flow parameters for cv2.calcOpticalFlowFarneback

docs.opencv.org/2.4/modules/video/doc/motion_analysis_and_object_tracking.html#calcopticalflowfarneback
'''

pyr_scale = 0.5 
levels = 3
winsize = 15
iterations = 3
poly_n = 5
poly_sigma = 1.2
flags = 0


'''
write out a video
'''
video_write = False

'''
write out images
'''
image_write = False

'''
Whether to display the video
'''
displayVideo = True

'''
Whether to calculate optical flow
'''
calc_flow = False

'''
insert frame number into frame
'''
insert_frame_number = True

'''
draw existing exemplars into frame
'''
place_existing_exemplars = True

'''
has exemplar point and label info
'''
   
#pickle_path_old = path_common + path_specific + exemplar_old
pickle_path = sys.argv[1]
              
with open(pickle_path, 'rb') as f:
    exemplar_points_and_labels = pickle.load(f)
    
with open(sys.argv[2], 'rb') as f:
    patch_points_and_labels = pickle.load(f)

      
# process the mp4 video
cap = cv2.VideoCapture(video_path)

num_frames = cap.get(cv2.CAP_PROP_FRAME_COUNT)
fps = cap.get(cv2.CAP_PROP_FPS )

'''Frames to advance between frames passed to optical flow'''
framesToAdvance = np.int32(np.ceil(fps / 15))

print('number of frames:', num_frames, ', frames per second:', fps,
      'framesToAdvance:', framesToAdvance)



# initialize frame1
success_flag, frame1_full = cap.read()

assert success_flag, "On first attempt after construction, could \
                      not read frame from {}".format(video_path)  
                            
frame1 = cv2.resize(frame1_full, (0,0), fx=scaleFactor, fy=scaleFactor) 
frame1_gray = cv2.cvtColor(frame1,cv2.COLOR_BGR2GRAY)

'''
save frames
'''
segment = True
seconds = 3
if segment == True:
    num_frames = np.int32(np.ceil(seconds * fps))
    number_saved = np.int32(np.ceil(seconds * fps / framesToAdvance))
    print('number saved:', number_saved)
    
else:
    num_frames = 300
    number_saved = 75


saved_frames = []
frame_number = []
ind = -1

# prep window
title = 'display window'
move_window = [60, -30]
cv2.namedWindow(title, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
cv2.moveWindow(title, move_window[0], move_window[1])
#cv2.moveWindow(title, -468, -1111)
#cv2.moveWindow(title, -234, -900)

# loop through the frames and display

# announce
print("Press Esc on the image to exit")

e1 = cv2.getTickCount()

count = 0


# for when write_video is true
if video_write == True:
    
    fourcc = cv2.VideoWriter_fourcc(*'XVID')
    root, ext = os.path.splitext(video_path)
    video_path_less_frames = root + '__skipped_' + str(framesToAdvance - 1) + ext
    out = cv2.VideoWriter(video_path_less_frames, fourcc, 20, 
                          tuple(np.flip(frame1_full.shape[0:2], 0)))
    
    if out.isOpened():
        out.write(frame1_full)
    else:
        print('\nout not open\n')
        
# for when image_write is true
if image_write == True:
    
    image_path = path_common + path_specific + 'images/' + \
        video_name[0:-4] + '__'+ '{:05d}'.format(count + 1) + '.png'
    
    cv2.imwrite(image_path, frame1)

# last frame got was the last
last_frame = False

while(cap.isOpened()):
                
    # skip frames
    for i in range(framesToAdvance):
        success_flag, frame2_full = cap.read()
        
        count += 1

        if (not success_flag):
            print("no more frames in this capture")
            last_frame = True
                 
    if success_flag or last_frame == True:
    # process upon true read frame success_flag
    
        if count > 0:
            
            if last_frame is False:
        
                if video_write:
            
                    if out.isOpened():
                        out.write(frame2_full)
                    else:
                        print('\nout not open\n')
                        
                #initialize frame2
                frame2 = cv2.resize(frame2_full, (0,0), fx=scaleFactor, fy=scaleFactor)             
                frame2_gray = cv2.cvtColor(frame2, cv2.COLOR_BGR2GRAY)
        
                if image_write == True:    
                    
                    image_path = path_common + path_specific + 'images/' + \
                    video_name[0:-4] + '__'+ '{:05d}'.format(count + 1) + '.png'
                    
                    cv2.imwrite(image_path, frame2)
                
                
                if count > frame_wait and calc_flow == True:
                    # calculate the flow between frame1 and frame2    
                    flow = cv2.calcOpticalFlowFarneback(frame1_gray, frame2_gray,
                                                        flow=None,
                                                        pyr_scale=pyr_scale, levels=levels,
                                                        winsize=winsize,
                                                        iterations=iterations,
                                                        poly_n=poly_n,
                                                        poly_sigma=poly_sigma, flags=flags)
                    
                    mag = np.sqrt(flow[...,0]**2 + flow[..., 1]**2)
                    
                    bp1 = plt.boxplot(np.reshape(mag, -1))
                    plt.show()
                    
                    mask1 = mag > bp1['whiskers'][1].get_data()[1][1]
                    
                    bp2 = plt.boxplot(mag[mask1])
                    plt.show()
                    
                    mask = (mag > bp2['medians'][0].get_data()[1][0]).astype(np.uint8)
                    
                    kernel = np.ones((5,5),np.uint8)
                    
                    mask = cv2.morphologyEx(mask, cv2.MORPH_OPEN, kernel)
                    mask = cv2.dilate(mask, kernel)
                    
                    
                    
                    
                if displayVideo == True:
                    
                    if count > frame_wait and calc_flow == True:
        
                        if normalize_scale and normalize_frame_advance:                
                            frame_to_diplay = fns.draw_flow(frame1_gray,
                                                            flow * (1 / scaleFactor) \
                                                            / framesToAdvance,
                                                            mask, step=4)
                        elif normalize_scale:                
                            frame_to_diplay = fns.draw_flow(frame1_gray,
                                                            flow * (1 / scaleFactor),
                                                            mask, step=4)
                        elif normalize_frame_advance:                
                            frame_to_diplay = fns.draw_flow(frame1_gray,
                                                            flow / framesToAdvance,
                                                            mask, step=4)
                        else:                
                            frame_to_diplay = fns.draw_flow(frame1_gray, flow,
                                                            mask, step=4)  
                    elif calc_flow == False:
                        
                        frame_to_display = frame1
        
                    if insert_frame_number == True:
                                        
                        # draw the text
                        cv2.putText(frame_to_display, str(count - framesToAdvance),
                                    (frame_to_display.shape[1] - 100, 25),
                                     cv2.FONT_HERSHEY_SIMPLEX, 1, (0, 255, 0), 2)
                        
                    if place_existing_exemplars == True:
                        
                        if len(exemplar_points_and_labels.keys()) > 0:
                            
                            frame_num = (count - framesToAdvance)
                            
                            ranges = \
                                np.array(list(exemplar_points_and_labels.keys()))
                            
                            relevant = \
                                np.where(np.all([ranges[:, 0] <= int(frame_num),
                                                 ranges[:, 1] >= int(frame_num)],
                                                axis=0))[0]
            
                            if len(relevant) > 0:
                                
                                for rel in relevant:
                                    
                                    key = tuple(ranges[rel])
                                    
                                    for i, pts in enumerate(exemplar_points_and_labels[key][0]):
                                        
                                        descriptor = \
                                            exemplar_points_and_labels[key][1][i]
                                            
                                            
                                        color = [bgr for d, bgr in \
                                                 zip(['predominately head',
                                                      'predominately hand',
                                                      'predominately both'],
                                                       [(0, 0, 255),
                                                        (0, 255, 255),
                                                        (0, 127, 255)]) \
                                                        if d == descriptor]
                                                 
                                        descr = [d[14:] for d in \
                                                 ['predominately head',
                                                  'predominately hand',
                                                  'predominately both'] \
                                                  if d == descriptor]
                                                 
                                        cv2.rectangle(frame_to_display,
                                                      tuple(pts[0:2]),
                                                      tuple(pts[2:]),
                                                      color[0])
                                        
                                        cv2.rectangle(frame_to_display,
                                                      tuple(pts[0:2]),
                                                      tuple(pts[0:2] + \
                                            np.array([len(descr[0]) * 6, 9])),
                                                      color[0], -1)
                                                      
                                        cv2.putText(frame_to_display, descr[0],
                                            tuple(pts[0:2] + np.array([0, 6])),
                                                    cv2.FONT_HERSHEY_DUPLEX, 0.3,
                                                    (0, 0, 0), 1)
                                        
                                        
                                    for i, pts in enumerate(patch_points_and_labels[key][0]):
                                        
                                        descriptor = \
                                            patch_points_and_labels[key][1][i]
                                            
                                            
                                        color = [bgr for d, bgr in \
                                                 zip(['predominately head',
                                                      'predominately hand',
                                                      'predominately both',
                                                      'predominately non-exemplar'],
                                                       [(255, 0, 0),
                                                        (255, 255, 0),
                                                        (0, 127, 255),
                                                        (0, 0, 0)]) \
                                                        if d == descriptor]
                                        
                                        descr = [d[14:] for d in \
                                                 ['predominately head',
                                                  'predominately hand',
                                                  'predominately both',
                                                  'predominately non-exemplar'] \
                                                  if d == descriptor]
                                        
                                        print(descr[0])
                                        if descr[0] != 'non-exemplar':
                                            
                                            cv2.rectangle(frame_to_display,
                                                          tuple(pts[0:2]),
                                                          tuple(pts[2:]),
                                                          color[0])
    
                                            cv2.rectangle(frame_to_display,
                                                tuple(pts[0:2]), tuple(pts[0:2] + \
                                                np.array([pts[2]-pts[0], 9])),
                                                color[0], -1)
                                                      
                                            cv2.putText(frame_to_display, str(i),
                                                tuple(pts[0:2] + np.array([0, 6])),
                                                cv2.FONT_HERSHEY_DUPLEX, 0.3,
                                                (0, 0, 0), 1)
                                            
                                            
    #                                    elif i in might_fix_indices:
    #                                        
    #                                        cv2.rectangle(frame_to_display,
    #                                                      tuple(pts[0:2]),
    #                                                      tuple(pts[2:]),
    #                                                      color[0])
    #
    #                                        cv2.rectangle(frame_to_display,
    #                                            tuple(pts[0:2]), tuple(pts[0:2] + \
    #                                            np.array([pts[2]-pts[0], 9])),
    #                                            color[0], -1)
    #                                                  
    #                                        cv2.putText(frame_to_display, descr[0],
    #                                            tuple(pts[0:2] + np.array([0, 6])),
    #                                            cv2.FONT_HERSHEY_DUPLEX, 0.3,
    #                                            (255, 187, 0), 1)
    
                                        
                                        
        
        
                    cv2.imshow(title, frame_to_display)
        
                saved_frames.append(frame_to_display)
                
                if reduced_frames == True:
                    frame_number.append(str((count - framesToAdvance) * 4))
                else:
                    frame_number.append(str(count - framesToAdvance))
                
                if len(saved_frames) > number_saved:
                    saved_frames.pop(0)
                    frame_number.pop(0)
                else:
                    ind = ind + 1
        
        
                # update frame1
                frame1 = frame2
                frame1_gray = frame2_gray
                
            else:
                # draw the text
                cv2.putText(saved_frames[-1], 'last', (25, 25),
                            cv2.FONT_HERSHEY_SIMPLEX, 1, (0, 255, 0), 2)
                
                cv2.imshow(title, saved_frames[-1])
                
                    
            # Esc key press will escape
            k = cv2.waitKey(1) & 0xff
            if k == 27:
    
                # release capture
                cap.release()
    
                # close all the OpenCV windows
                cv2.destroyAllWindows()
                
                break
            # space key will pause
            elif k == 32 or (segment == True and count % num_frames == 0):
        
                # allow scrolling
                k = -1
                    
                # until we get another space key
                allow_scrolling = True
    
                while(allow_scrolling):
                
                    k = cv2.waitKey(1)
                    
                    # space or escape
                    if k == 32 or k == 27:
                
                        allow_scrolling = False
                    
                    # > arrow
                    elif k == 46:
                
                        if ind < len(saved_frames) - 1:
                            
                            ind = ind + 1
                            cv2.imshow(title, saved_frames[ind])
                    
                    # < arrow
                    elif k == 44:
                        
                        if ind > 0:
                            
                            ind = ind - 1
                            cv2.imshow(title, saved_frames[ind])
    
    
                 
    #            According to "A Byte of Python", "The else block is executed when
    #            the while loop condition becomes False - this may even be the first
    #            time that the condition is checked. If there is an else clause for
    #            a while loop, it is always executed unless you break out of the
    #            loop with a break statement."
                
                else:
                    
                    # escape
                    if k == 27:
    
                        # release capture
                        cap.release()
            
                        # close all the OpenCV windows
                        cv2.destroyAllWindows()
                        
                        break
                    
                    # space
                    if k == 32:
                        
                        get_back = True
                        
                        while(get_back):
                            
                            if ind + 1 == len(saved_frames):
                                
                                get_back = False
                                
                            else:
                                
                                ind = ind + 1
                                
                                cv2.imshow(title, saved_frames[ind])
                                
                                k = cv2.waitKey(1)
                                
                                if k == 27:
                                    
                                    get_back = False
    
                        else:
                            
                            # escape
                            if k == 27:
            
                                # release capture
                                cap.release()
                    
                                # close all the OpenCV windows
                                cv2.destroyAllWindows()
                                
                                break                            
             
    else:

        # release capture
        cap.release()

        # close all the OpenCV windows
        cv2.destroyAllWindows()

if video_write == True:
    
    out.release()

e2 = cv2.getTickCount()
time = (e2 - e1)/ cv2.getTickFrequency()
print("Execution time in seconds = ", time)
