# -*- coding: utf-8 -*-
"""
Created on Sun Mar 25 14:18:23 2018

@author: Callie Darsey

getting_exemplars_while_viewing_flow_info_01
"""

import numpy as np
import cv2
import fns_investigating_optical_flow_01 as fns
import os
import Adjustable_BB_04 as Adjustable_BB
import datetime
import pickle
import sys

# video path
common_path = './video_copies_clips_track/copies_and_clips_facilitator_C/'
specific_path = 'STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__200_208/'
video_name = 'MVI_0028_trans__200_208.mp4'


directory = common_path + specific_path

dir_list = os.listdir(directory)

collect_listings = []

for listing in dir_list:
    
    if 'flow_' + video_name[0:-4] in listing and listing[-5:] == '.data':
        
        collect_listings.append(listing)

collect_listings.sort()

# prep window
title = 'display window'
move_window = [60, -30]
cv2.namedWindow(title, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
cv2.moveWindow(title, move_window[0], move_window[1])



'''
hold exemplar point info
'''
exemplar_points = {}

'''pickle info old'''
use_old_exemplar = False

if use_old_exemplar == True:
    
    pickle_path_old = sys.argv[1]
                  
    with open(pickle_path_old, 'rb') as f:
        exemplar_points = pickle.load(f)

'''pickle info new'''
n = datetime.datetime(1, 1, 1).now()
timestamp = 'y{:d}m{:02d}d{:02d}-h{:02d}m{:02d}s{:02d}.{:d}'. \
            format(n.year, n.month, n.day,
                   n.hour, n.minute, n.second, n.microsecond)
pickle_path = common_path + specific_path + \
              'exemplars___' + video_name[0:-4] + '___'+ \
              timestamp + '.data'

'''
save frames
'''
number_saved = 50
saved_frames = []
frame_number = []
ind = -1

# loop through the frames and display

# announce
print("Press Esc on the image to exit")

e1 = cv2.getTickCount()

last = len(collect_listings)
count = 0

for listing in collect_listings:
    
    # increment count
    count = count + 1
    
    # pickle result
    pickle_path_flow = common_path + specific_path + listing
        
    with open(pickle_path_flow, 'rb') as f:
        frame1, frame2, flow, frame_to_display = pickle.load(f)
    
    # mark last frame    
    if count == last:
        # draw the text
        cv2.putText(frame_to_display, 'last', (25, 25),
                    cv2.FONT_HERSHEY_SIMPLEX, 1, (0, 255, 0), 2)        
 
    # use or initialize frame in exemplar
    frame_num = int(listing[-14:-10])
    
    if frame_num in exemplar_points.keys():
        
        if exemplar_points[frame_num] is not None:
        
            for pts in exemplar_points[frame_num]:
                
                cv2.rectangle(frame_to_display, tuple(pts[0:2]),
                              tuple(pts[2:]), (0, 255, 0))
    else:             
        exemplar_points[frame_num] = None

                        
    cv2.imshow(title, frame_to_display)

    saved_frames.append(frame_to_display)
    frame_number.append(frame_num)
    
    if len(saved_frames) > number_saved:
        saved_frames.pop(0)
        frame_number.pop(0)
    else:
        ind = ind + 1

            
    # catch a key press
    k = cv2.waitKey(1)
    
    # Esc key press will escape
    if k == 27:

        # close all the OpenCV windows
        cv2.destroyAllWindows()
        
        break
    
    # space key will pause
    elif k == 32 or count == last:
        
        k = -1
        
        # until we get another space key
        allow_scrolling = True
        while(allow_scrolling):
        
            k = cv2.waitKey(1)
            
            # space or escape
            if k == 32 or k == 27:

                allow_scrolling = False
            
            # left arrow
            elif k == 37:
                
                if ind > 0:
                    
                    ind = ind - 1
                    cv2.imshow(title, saved_frames[ind])
            
            # right arrow
            elif k == 39:
                
                if ind < len(saved_frames) - 1:
                    
                    ind = ind + 1
                    cv2.imshow(title, saved_frames[ind])
                    
            # n
            elif k == 110:

                wnd_name = 'make ROI, press escape or space to leave ROI mode'
                cv2.namedWindow(wnd_name,
                                cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
                cv2.moveWindow(wnd_name, move_window[0], move_window[1])
                
                # x, y, width, height
                x, y, width, height = cv2.selectROI(wnd_name,
                                                    saved_frames[ind],
                                                    False, False)
                cv2.destroyWindow(wnd_name)
                
                # allow for adjusting bounding box 

                prompt = 'Are ready to leave?\n\n\n' + \
                         'Yes to close adjustment window and save box.\n\n' + \
                         'No to continue adjusting.\n\n' + \
                         'Quit to close adjustment window without saving.\n\n'    
                abb = Adjustable_BB.AdjustableBB(prompt)
                
                wnd_abb = 'drag borders to adjust, click in box to leave'
                frame_canvas = np.copy(saved_frames[ind])
                point1 = (int(x + width - 1), int(y + height - 1))
                point2 = (int(x), int(y))
                
                abb.act(wnd_abb, frame_canvas, point1, point2, move_window)
                
                print('done with adjusting')
                
                # save and draw
                print('abb.get_reply()', abb.get_reply())
                if abb.get_reply() == 'yes':
                    
                    points = abb.get_points()
                    
                    if exemplar_points[frame_number[ind]] is None:
                        
                        exemplar_points[frame_number[ind]] = \
                            np.array([points])
                        
                    else:
                        exemplar_points[frame_number[ind]] = \
                            np.vstack([exemplar_points[frame_number[ind]],
                                       points])

                    # pickle                                     
                    print(pickle_path)                        
                    with open(pickle_path, 'wb') as f:
                        pickle.dump((exemplar_points), f)
                        
                    
                        
                    saved_frames[ind] = cv2.rectangle(saved_frames[ind],
                                                      tuple(points[0:2]),
                                                      tuple(points[2:]),
                                                      (0, 255, 200), 1)
                    
                    cv2.imshow(title, saved_frames[ind])
                
                
                
#            According to "A Byte of Python", "The else block is executed when
#            the while loop condition becomes False - this may even be the first
#            time that the condition is checked. If there is an else clause for
#            a while loop, it is always executed unless you break out of the
#            loop with a break statement."
        
        else:
            
            # escape
            if k == 27:
    
                # close all the OpenCV windows
                cv2.destroyAllWindows()
                
                break
            
            # space
            if k == 32:
                
                get_back = True
                
                while(get_back):
                    
                    if ind + 1 == len(saved_frames):
                        
                        get_back = False
                        
                    else:
                        
                        ind = ind + 1
                        
                        cv2.imshow(title, saved_frames[ind])
                        
                        k = cv2.waitKey(1)
                        
                        if k == 27:
                            
                            get_back = False

                else:
                    
                    # escape
                    if k == 27:

                        # close all the OpenCV windows
                        cv2.destroyAllWindows()
                        
                        break   

# close all the OpenCV windows
cv2.destroyAllWindows()


e2 = cv2.getTickCount()
time = (e2 - e1)/ cv2.getTickFrequency()
print("Execution time in seconds = ", time)

# pickle
with open(pickle_path, 'wb') as f:
    pickle.dump((exemplar_points), f)