# -*- coding: utf-8 -*-
"""
Created on Tue Apr  3 11:41:20 2018

@author: Callie Darsey

Peak and Valley Detection
"""



import cv2
import numpy as np
import pickle
import os
import fns_investigating_optical_flow_01 as fns
from matplotlib import pyplot as plt
import get_lessened_features_and_save_steps_01 as get
import overlay_01 as overlay
import component_functions_01 as comp_fns


# video path
common_path = './video_copies_clips_track/copies_and_clips_facilitator_C/'
specific_path = 'STI Polk Apr06 C/MVI_0028_trans/MVI_0028_trans__200_208/'
video_name = 'MVI_0028_trans__200_208.mp4'



regions_path = 'adjust_review_03/region_masks/'

collect_max_flow_mag_per_frame = []

# prep window
title = 'display window'
move_window = [0, -30]
cv2.namedWindow(title, cv2.WINDOW_GUI_NORMAL | cv2.WINDOW_AUTOSIZE)
cv2.moveWindow(title, move_window[0], move_window[1])

for f1n in range(0, 464, 4):

    flow_name = 'flow_MVI_0028_trans__200_208_' + '{:04d}'.format(f1n) + \
                 '_' + '{:04d}'.format(f1n + 4) + '.data'
    
    # load pickled flow    
    with open(common_path + specific_path + flow_name, 'rb') as f:
        frame1, frame2, flow, f2d = pickle.load(f)
        
    # calc flow mag sum
    flow_mag = cv2.magnitude(flow[:, :, 0], flow[:, :, 1])
    
#    # draw flow arrows
#    arrows = np.copy(frame1)
#    fns.draw_flow(arrows, flow, (flow_mag != 0.0), step=4)    
    
    # print    
    print('{:04d}'.format(f1n), np.count_nonzero(flow_mag == 0.0))
    
    if f1n == 0:
        
        flow_mag_sum = np.copy(flow_mag)
    
    else:
        
        flow_mag_sum = flow_mag_sum + flow_mag
        
    
    
    # collect
    collect_max_flow_mag_per_frame.append(np.max(flow_mag))
    
    # for display
    flow_mag_display = (255 * flow_mag / np.max(flow_mag)).astype(np.uint8)
    flow_mag_display_C3 = np.stack([flow_mag_display,
                                    flow_mag_display,
                                    flow_mag_display], axis=2)
    
    cv2.imshow(title, flow_mag_display)


    
    k = cv2.waitKey(1)
    if k == 27:
        break

# for display
flow_mag_sum_display = \
    (255 * flow_mag_sum / np.max(flow_mag_sum)).astype(np.uint8)

cv2.imshow(title, flow_mag_sum_display)

cv2.waitKey(0)

        
cv2.destroyAllWindows()


plt.figure(figsize=(100, 3))
plt.plot(np.arange(0, 464, 4), collect_max_flow_mag_per_frame, marker='.')
        
