# -*- coding: utf-8 -*-
"""
Created on Sat May 19 13:23:07 2018

@author: Callie Darsey

prune_training_set_01
"""


import pickle
import numpy as np
import sklearn.ensemble as ske
import sklearn.metrics as skmet
import sklearn.neighbors as skn
import sklearn.linear_model as sklm
import sklearn.model_selection as sklms
import matplotlib.pyplot as plt
import cv2
import sklearn.tree as sklt

def merge_my_dicts(d_list):
    '''
    '''
    print('merging')
    my_merged_dict = {}
    
    for key in d_list[0].keys():
        #print(key)
        
        for d in d_list[1:]:
            assert key in d.keys()
            assert np.count_nonzero([d_list[0][key][0] != d[key][0]]) == 0
            assert d_list[0][key][1] == d[key][1]
            
        val = [d_list[0][key][0], d_list[0][key][1]]
        
        features = []
        
        for d in d_list:
            
            features = features + [d[key][2]]
            
        val = val + [np.hstack(features)]

        my_merged_dict[key] = val
        
    return my_merged_dict


        
e1 = cv2.getTickCount()

'''
"patches_all_segments_labels___feature_correct_hist_of_flow_Bins_32___",
"patches_all_segments_labels___feature_correct_hist_of_flow_div_counts_Bins_32___",
"patches_all_segments_labels___feature_correct_hists_of_flow_Bins_32___",
"patches_all_segments_labels___feature_correct_hists_of_flow_div_counts_Bins_32___",
"patches_all_segments_labels___feature_correct_sum_hists_of_flow_div_counts_Bins_32___",
"patches_all_segments_labels___feature_skin_bool_Bins_32___",
"patches_all_segments_labels___feature_skin_count_Bins_32___",
"patches_all_segments_labels___feature_watershed_skin_bool_Bins_32___",
'patches_all_segments_labels___feature_flow_mag_sum_all_Bins_32___'
'''

upper = './wheeler/dataset/'
tags = ['patches_all_segments_labels___feature_skin_bool_Bins_32___',
        'patches_all_segments_labels___feature_watershed_skin_bool_Bins_32___',
        'patches_all_segments_labels___feature_flow_mag_sum_all_Bins_32___',
        'patches_all_segments_labels___feature_skin_count_Bins_32___']

ftypes = ['skin bool',
          'watershed skin bool',
          'flow mag sum all',
          'skin count']

clip_infos = [[]] * 15

names = [\
'part1/MVI_0069_trans/',
'STI_Polk_Apr13_C/MVI_0039_trans/',
'STI_Polk_Apr27_A/MVI_0073_trans/',
'STI_Polk_Apr27_D/MVI_0063_trans/',
'STI_Polk_May04_A/MVI_0087_trans/',
'STI_Polk_May11_C/MVI_0108_trans/',
'STI_WA_Apr11_extra_B/MVI_0036_trans/',
'STI_WA_Jun12_B/MVI_0018_trans/',
'STI_WA_Jun14_Lb/MVI_0070_trans/',
'STI_WA_Jun20_CT/MVI_0029_trans/',
'STI_WA_Jun22_De/MVI_0118_trans/',
'STI_WA_Jun23_Da/MVI_0112_trans/',
'STI_WA_May02_B/MVI_0053_trans/',
'STI_WA_May02_C/MVI_0074_trans/',
'STI_WA_May09_A/MVI_0109_trans/']
         

for tag in tags:
    
    clip_info = [\
    upper + 'part1/MVI_0069_trans/' + tag + 'MVI_0069_trans__0_100.data',
    upper + 'STI_Polk_Apr13_C/MVI_0039_trans/' + tag + 'MVI_0039_trans__460_563.data',
    upper + 'STI_Polk_Apr27_A/MVI_0073_trans/' + tag + 'MVI_0073_trans__0_100.data',
    upper + 'STI_Polk_Apr27_D/MVI_0063_trans/' + tag + 'MVI_0074_trans__240_342.data',
    upper + 'STI_Polk_May04_A/MVI_0087_trans/' + tag + 'MVI_0087_trans__579_680.data',
    upper + 'STI_Polk_May11_C/MVI_0108_trans/' + tag + 'MVI_0108_trans__0_42.data',
    upper + 'STI_WA_Apr11_extra_B/MVI_0036_trans/' + tag + 'MVI_0036_trans__870_912.data',
    upper + 'STI_WA_Jun12_B/MVI_0018_trans/' + tag + 'MVI_0018_trans__910_954.data',
    upper + 'STI_WA_Jun14_Lb/MVI_0070_trans/' + tag + 'MVI_0070_trans__670_712.data',
    upper + 'STI_WA_Jun20_CT/MVI_0029_trans/' + tag + 'MVI_0029_trans__515_557.data',
    upper + 'STI_WA_Jun22_De/MVI_0118_trans/' + tag + 'MVI_0118_trans__100_142.data',
    upper + 'STI_WA_Jun23_Da/MVI_0112_trans/' + tag + 'MVI_0112_trans__15_57.data',
    upper + 'STI_WA_May02_B/MVI_0053_trans/' + tag + 'MVI_0053_trans__0_100.data',
    upper + 'STI_WA_May02_C/MVI_0074_trans/' + tag + 'MVI_0074_trans__60_102.data',
    upper + 'STI_WA_May09_A/MVI_0109_trans/' + tag + 'MVI_0109_trans__0_42.data']
    
    for i, data in enumerate(clip_info):
        
        clip_infos[i] = clip_infos[i] + [data]


segment = 45

# holds head and hand feature vectors per clip

non_exemplar_feature_vectors_per_clip = []
exemplar_head_feature_vectors_per_clip = []
exemplar_hand_feature_vectors_per_clip = []

for clip in clip_infos:
    
    patches_infos = []
    
    for data in clip:
        
        with open(data, 'rb') as f:
            
            patches_info = pickle.load(f)
                        
        patches_infos.append(patches_info)
    
    patches_info_merged = merge_my_dicts(patches_infos)
    

    non_exemplar_clip = []
    exemplar_head_clip = []
    exemplar_hand_clip = []
        
    for info in patches_info_merged.values():
        
        patches, tags, feature = info[0], info[1], info[2]
        
        col_start, row_start, col_end, row_end = tuple(patches[0])
        patch_size = (col_end - col_start + 1) * (row_end - row_start + 1)
        
        tags_ar = np.array(tags)
        
        
        # group according to tags
        non_exemplar_indices = \
            np.where(tags_ar == 'predominately non-exemplar')[0]        
        
        
        exemplar_head_indices = np.where(np.any(\
                                            [tags_ar == 'predominately head',
                                            tags_ar == 'predominately both'],
                                            axis=0))[0]

        exemplar_hand_indices = np.where(tags_ar == 'predominately hand')[0]        

        # features
        if len(non_exemplar_indices) > 0:

            non_exemplar_clip.append(feature[non_exemplar_indices, :])            
        
        if len(exemplar_head_indices) > 0:
            
            exemplar_head_clip.append(feature[exemplar_head_indices, :])
            
        if len(exemplar_hand_indices) > 0:
            
            exemplar_hand_clip.append(feature[exemplar_hand_indices, :])
            
    # stack for clip
    non_exemplar_clip = np.vstack(non_exemplar_clip)
    exemplar_head_clip = np.vstack(exemplar_head_clip)
    exemplar_hand_clip = np.vstack(exemplar_hand_clip)
    
    
    # collect per clip
    non_exemplar_feature_vectors_per_clip.append(non_exemplar_clip)
    exemplar_head_feature_vectors_per_clip.append(exemplar_head_clip)
    exemplar_hand_feature_vectors_per_clip.append(exemplar_hand_clip)
    

indices = np.arange(len(clip_infos))

non_exemplar_fraction_kept = []
exemplar_head_fraction_kept = []
exemplar_hand_fraction_kept = []

print('')

non_exemplar_indices_keep_clip = []
exemplar_head_indices_keep_clip = []
exemplar_hand_indices_keep_clip = []

for i in indices:
    
    ei = cv2.getTickCount()
    
    train_non_exemplar = non_exemplar_feature_vectors_per_clip.copy()
    train_exemplar_head = exemplar_head_feature_vectors_per_clip.copy()
    train_exemplar_hand = exemplar_hand_feature_vectors_per_clip.copy()
    
    
    val_test_exemplar_head = train_exemplar_head.pop(i)
    val_test_exemplar_hand = train_exemplar_hand.pop(i)
    val_test_non_exemplar = train_non_exemplar.pop(i)
    
#    # stack
#    train_non_exemplar = np.vstack(train_non_exemplar)
#    train_exemplar_head = np.vstack(train_exemplar_head)
#    train_exemplar_hand = np.vstack(train_exemplar_hand)
#   
#    
#    X = np.vstack([train_non_exemplar,
#                   train_exemplar_head,
#                   train_exemplar_hand])
#    
#    print('X.shape', X.shape, ' (',
#          'train_non_exemplar.shape', train_non_exemplar.shape,                       
#          'train_exemplar_head.shape', train_exemplar_head.shape,
#          'train_exemplar_hand.shape', train_exemplar_hand.shape,')')
        
    X_LOO = np.vstack([val_test_non_exemplar,
                       val_test_exemplar_head,
                       val_test_exemplar_hand])
    
#    # 0 for non-exemplar, 1 for exemplar
#    y_train = np.hstack([np.zeros(len(train_non_exemplar)),
#                         np.ones(len(train_exemplar_head)),
#                         np.ones(len(train_exemplar_hand)) * 2])
    
    # counts in original number of patches        
    non_exemplar_count = len(val_test_non_exemplar)
    exemplar_head_count = len(val_test_exemplar_head)
    exemplar_hand_count = len(val_test_exemplar_hand)            
            
    y_val = np.hstack([np.zeros(non_exemplar_count),
                       np.ones(exemplar_head_count),
                       np.ones(exemplar_hand_count) * 2])
    
#    # leave-one-out test
#    print('X_LOO.shape', X_LOO.shape, ' (',
#          'val_test_non_exemplar.shape', val_test_non_exemplar.shape,
#          'val_test_exemplar_head.shape', val_test_exemplar_head.shape,
#          'val_test_exemplar_hand.shape', val_test_exemplar_hand.shape,')')
            
    print(''); print(names[i])

    y_mark_keep_skin = np.zeros_like(y_val)
    y_mark_keep_watershed_skin = np.zeros_like(y_val)
    y_mark_keep_flow_mag_sum_all = np.zeros_like(y_val)
    y_mark_keep_skin_count = np.zeros_like(y_val)
    
    y_mark_keep_skin[np.where(X_LOO[:, 0] > 0)[0]] = 1
    
    y_mark_keep_watershed_skin[np.where(X_LOO[:, 1] > 0)[0]] = 1
    
    flow_mag_sum_all = 100
    fraction_of_area = 0.3

    y_mark_keep_flow_mag_sum_all[np.where(np.all(\
        [X_LOO[:, 2] > flow_mag_sum_all], axis=0))[0]] = 1
            
    y_mark_keep_skin_count[np.where(np.all(\
        [X_LOO[:, 3] / patch_size > fraction_of_area,
         X_LOO[:, 3] / patch_size <= 1.0 ],axis=0))[0]] = 1
    
    y_mark_keep = np.all([y_mark_keep_skin_count,
                          y_mark_keep_flow_mag_sum_all], axis=0)
            
    # keep per class
    non_exemplar_mask = np.all([y_mark_keep == 1, y_val == 0], axis=0)
    exemplar_head_mask = np.all([y_mark_keep == 1, y_val == 1], axis=0)
    exemplar_hand_mask = np.all([y_mark_keep == 1, y_val == 2], axis=0)

    non_exemplar_indices_keep = \
        np.where(np.all([y_mark_keep == 1, y_val == 0], axis=0))[0] - \
        non_exemplar_count
        
    exemplar_head_indices_keep = \
        np.where(np.all([y_mark_keep == 1, y_val == 1], axis=0))[0] - \
        exemplar_head_count - non_exemplar_count
        
    exemplar_hand_indices_keep = \
        np.where(np.all([y_mark_keep == 1, y_val == 2], axis=0))[0] - \
        exemplar_hand_count - exemplar_head_count - non_exemplar_count
    
    non_exemplar_indices_keep_clip.append(non_exemplar_indices_keep)
    exemplar_head_indices_keep_clip.append(exemplar_head_indices_keep)
    exemplar_hand_indices_keep_clip.append(exemplar_hand_indices_keep)   
            
    # report
    non_exemplar_kept = len(non_exemplar_indices_keep)
    exemplar_head_kept = len(exemplar_head_indices_keep)
    exemplar_hand_kept = len(exemplar_hand_indices_keep)
    
    
    header = '{:13s}  {:5s}  {:5s}  {:9s}'
    row = '{:13s}  {:5d}  {:5d}  {:9.3f}'
    print(header.format('patch', 'count', 'kept', 'fraction'))
    print(header.format('label', '', '', 'kept'))
    
    print(row.format('non-exemplar', non_exemplar_count, non_exemplar_kept,
                     non_exemplar_kept/non_exemplar_count))
    
    print(row.format('exemplar-head', exemplar_head_count, exemplar_head_kept,
                     exemplar_head_kept / exemplar_head_count))
    
    print(row.format('exemplar-hand', exemplar_hand_count, exemplar_hand_kept,
                     exemplar_hand_kept / exemplar_hand_count))
    

    non_exemplar_fraction_kept.append(non_exemplar_kept/non_exemplar_count)
    exemplar_head_fraction_kept.append(exemplar_head_kept/exemplar_head_count)
    exemplar_hand_fraction_kept.append(exemplar_hand_kept/exemplar_hand_count)
    
    # form sampled datasets
    
    
    ee = cv2.getTickCount()
    print("Per clip execution {:.2f} seconds".format(\
        (ee - ei) / cv2.getTickFrequency()))

print('\ntag(s):'); print(tag)
print('feature type(s):')
for ftype in ftypes:
    print(ftype)


non_exemplar_fraction_kept = np.vstack(non_exemplar_fraction_kept)
exemplar_head_fraction_kept = np.vstack(exemplar_head_fraction_kept)
exemplar_hand_fraction_kept = np.vstack(exemplar_hand_fraction_kept)

fraction_kept_row = 'Fraction Kept  non-exemplar     exemplar-head     exemplar-hand'
minimum_row       = '      Minimum  {:12.3f}     {:13.3f}     {:13.3f}'
median_row        = '       Median  {:12.3f}     {:13.3f}     {:13.3f}'
mean_row          = '         Mean  {:12.3f}     {:13.3f}     {:13.3f}'
maximum_row       = '      Maximum  {:12.3f}     {:13.3f}     {:13.3f}'

print(fraction_kept_row)

print(minimum_row.format(np.min(non_exemplar_fraction_kept), 
                         np.min(exemplar_head_fraction_kept),
                         np.min(exemplar_hand_fraction_kept)))
        
print(median_row.format(np.median(non_exemplar_fraction_kept),
                        np.median(exemplar_head_fraction_kept),
                        np.median(exemplar_hand_fraction_kept)))
        
print(mean_row.format(np.mean(non_exemplar_fraction_kept),
                      np.mean(exemplar_head_fraction_kept),
                      np.mean(exemplar_hand_fraction_kept)))
        
print(maximum_row.format(np.max(non_exemplar_fraction_kept),
                         np.max(exemplar_head_fraction_kept),
                         np.max(exemplar_hand_fraction_kept)))

flow_mag_sum_all = 100
fraction_of_area = 0.3
indices_path = './wheeler/dataset/thresholded_patches/' + \
               'remaining_indices.{:d}.{:.1f}.data'.format(flow_mag_sum_all,
                                                           fraction_of_area)

with open(indices_path, 'wb') as f:

    pickle.dump((non_exemplar_indices_keep_clip,
                 exemplar_head_indices_keep_clip,
                 exemplar_hand_indices_keep_clip), f)

e2 = cv2.getTickCount()
print("Total execution {:.2f} seconds".format(\
    (e2 - e1) / cv2.getTickFrequency()))
