# -*- coding: utf-8 -*-
"""
Created on Sun May 20 00:45:52 2018

@author: Callie Darsey

reduced_patches_LOO_02
"""


import pickle
import numpy as np
import sklearn.ensemble as ske
import sklearn.metrics as skmet
import sklearn.neighbors as skn
import sklearn.linear_model as sklm
import sklearn.model_selection as sklms
import sklearn.preprocessing as skpr
import sklearn.pipeline as skpi
import matplotlib.pyplot as plt
import cv2
import sklearn.tree as sklt
import datetime

def merge_my_dicts(d_list):
    '''
    '''
    print('merging')
    my_merged_dict = {}
    
    for key in d_list[0].keys():
        #print(key)
        
        for d in d_list[1:]:
            assert key in d.keys()
            assert np.count_nonzero([d_list[0][key][0] != d[key][0]]) == 0
            assert d_list[0][key][1] == d[key][1]
            
        val = [d_list[0][key][0], d_list[0][key][1]]
        
        features = []
        
        for d in d_list:
            
            features = features + [d[key][2]]
            
        val = val + [np.hstack(features)]

        my_merged_dict[key] = val
        
    return my_merged_dict


        
e1 = cv2.getTickCount()

'''
patches_labels_and_subset_feature_gray_skin_Bins_32___
patches_labels_and_subset_feature_gray_skin_Bins_32.uint8___

patches_labels_and_subset_feature_skin_bool_Bins_32___
patches_labels_and_subset_feature_skin_count_Bins_32___
patches_labels_and_subset_feature_watershed_skin_bool_Bins_32___
patches_labels_and_subsetagain_feature_flow_sum_all_mag_Bins_32___
patches_labels_and_subsetagain_feature_flow_mag_sum_all_Bins_32___

patches_labels_and_feature_correct_hists_of_flow_div_counts_Bins_32___
patches_labels_and_feature_correct_hist_of_flow_div_counts_Bins_32___


patches_labels_and_feature_correct_hist_of_flow_Bins_32___
patches_labels_and_feature_correct_hists_of_flow_Bins_32___
patches_labels_and_feature_correct_sum_hists_of_flow_div_counts_Bins_32___

patches_labels_and_subsetagain_feature_flow_ang_sum_Bins_32___
patches_labels_and_subsetagain_feature_flow_mag_sum_Bins_32___
patches_labels_and_subsetagain_feature_flow_sum_all_ang_Bins_32___

patches_labels_and_subsubset_feature_flow_ang_hist_Bins_32___
patches_labels_and_subsubset_feature_flow_ang_hists_Bins_32___
patches_labels_and_subsubset_feature_flow_mag_hist_Bins_32___
patches_labels_and_subsubset_feature_flow_mag_hists_Bins_32___

patches_labels_and_subset_feature_color_skin_Bins_32___
patches_labels_and_subset_feature_location_Bins_32___

'''

for t in range(1):
    upper = './wheeler/dataset/'
    tags = [\
        'patches_labels_and_feature_correct_hist_of_flow_div_counts_Bins_32___']
    
    ftypes = ['gray skin np.uint8 28x28']
    
    clip_infos = [[]] * 15
    
    for tag in tags:
        
        clip_info = [\
        upper + 'part1/MVI_0069_trans/' + tag + 'MVI_0069_trans__0_100.data',
        upper + 'STI_Polk_Apr13_C/MVI_0039_trans/' + tag + 'MVI_0039_trans__460_563.data',
        upper + 'STI_Polk_Apr27_A/MVI_0073_trans/' + tag + 'MVI_0073_trans__0_100.data',
        upper + 'STI_Polk_Apr27_D/MVI_0063_trans/' + tag + 'MVI_0074_trans__240_342.data',
        upper + 'STI_Polk_May04_A/MVI_0087_trans/' + tag + 'MVI_0087_trans__579_680.data',
        upper + 'STI_Polk_May11_C/MVI_0108_trans/' + tag + 'MVI_0108_trans__0_42.data',
        upper + 'STI_WA_Apr11_extra_B/MVI_0036_trans/' + tag + 'MVI_0036_trans__870_912.data',
        upper + 'STI_WA_Jun12_B/MVI_0018_trans/' + tag + 'MVI_0018_trans__910_954.data',
        upper + 'STI_WA_Jun14_Lb/MVI_0070_trans/' + tag + 'MVI_0070_trans__670_712.data',
        upper + 'STI_WA_Jun20_CT/MVI_0029_trans/' + tag + 'MVI_0029_trans__515_557.data',
        upper + 'STI_WA_Jun22_De/MVI_0118_trans/' + tag + 'MVI_0118_trans__100_142.data',
        upper + 'STI_WA_Jun23_Da/MVI_0112_trans/' + tag + 'MVI_0112_trans__15_57.data',
        upper + 'STI_WA_May02_B/MVI_0053_trans/' + tag + 'MVI_0053_trans__0_100.data',
        upper + 'STI_WA_May02_C/MVI_0074_trans/' + tag + 'MVI_0074_trans__60_102.data',
        upper + 'STI_WA_May09_A/MVI_0109_trans/' + tag + 'MVI_0109_trans__0_42.data']
        
        for i, data in enumerate(clip_info):
            
            clip_infos[i] = clip_infos[i] + [data]
    
    names = [\
    'part1/MVI_0069_trans/',
    'STI_Polk_Apr13_C/MVI_0039_trans/',
    'STI_Polk_Apr27_A/MVI_0073_trans/',
    'STI_Polk_Apr27_D/MVI_0063_trans/',
    'STI_Polk_May04_A/MVI_0087_trans/',
    'STI_Polk_May11_C/MVI_0108_trans/',
    'STI_WA_Apr11_extra_B/MVI_0036_trans/',
    'STI_WA_Jun12_B/MVI_0018_trans/',
    'STI_WA_Jun14_Lb/MVI_0070_trans/',
    'STI_WA_Jun20_CT/MVI_0029_trans/',
    'STI_WA_Jun22_De/MVI_0118_trans/',
    'STI_WA_Jun23_Da/MVI_0112_trans/',
    'STI_WA_May02_B/MVI_0053_trans/',
    'STI_WA_May02_C/MVI_0074_trans/',
    'STI_WA_May09_A/MVI_0109_trans/']
    
    segment = 45
    
    
    with open('./wheeler/dataset/thresholded_patches/remaining_indices.data', 'rb') as f:
    
        non_exemplar_indices_keep_clip, \
        exemplar_head_indices_keep_clip, \
        exemplar_hand_indices_keep_clip = pickle.load(f)
    
    
    # holds head and hand feature vectors per clip
    non_exemplar_feature_vectors_per_clip = []
    exemplar_head_feature_vectors_per_clip = []
    exemplar_hand_feature_vectors_per_clip = []
    
    for i, clip in enumerate(clip_infos):
        
        patches_infos = []
        
        for data in clip:
            
            with open(data, 'rb') as f:
                
                patches_info = pickle.load(f)
                            
            patches_infos.append(patches_info)
        
        patches_info_merged = merge_my_dicts(patches_infos)
        
    
        non_exemplar_clip = []
        exemplar_head_clip = []
        exemplar_hand_clip = []
            
        for info in patches_info_merged.values():
            
            patches, labels, feature = info[0], info[1], info[2]
            
            tags_ar = np.array(labels)
    
            # group according to tags
            non_exemplar_indices = \
                np.where(tags_ar == 'predominately non-exemplar')[0]        
            
            
            exemplar_head_indices = np.where(np.any(\
                                                [tags_ar == 'predominately head',
                                                tags_ar == 'predominately both'],
                                                axis=0))[0]
    
            exemplar_hand_indices = np.where(tags_ar == 'predominately hand')[0]
            
    
            # features
            if len(non_exemplar_indices) > 0:
    
                non_exemplar_clip.append(feature[non_exemplar_indices, :])            
            
            if len(exemplar_head_indices) > 0:
                
                exemplar_head_clip.append(feature[exemplar_head_indices, :])
                
            if len(exemplar_hand_indices) > 0:
                
                exemplar_hand_clip.append(feature[exemplar_hand_indices, :])
                
        # stack for clip
        non_exemplar_clip = np.vstack(non_exemplar_clip)
        exemplar_head_clip = np.vstack(exemplar_head_clip)
        exemplar_hand_clip = np.vstack(exemplar_hand_clip)
            
        # keep indices
        non_exemplar_indices_keep = non_exemplar_indices_keep_clip[i]
        exemplar_head_indices_keep = exemplar_head_indices_keep_clip[i]
        exemplar_hand_indices_keep = exemplar_hand_indices_keep_clip[i]
        
        print(non_exemplar_indices_keep.shape,
              exemplar_head_indices_keep.shape,
              exemplar_hand_indices_keep.shape, '         ',
              (non_exemplar_clip.shape[0],),
              (exemplar_head_clip.shape[0],),
              (exemplar_hand_clip.shape[0],))   
    
        # take only keep
        non_exemplar_clip = non_exemplar_clip[non_exemplar_indices_keep, :]
        exemplar_head_clip = exemplar_head_clip[exemplar_head_indices_keep, :]
        exemplar_hand_clip = exemplar_hand_clip[exemplar_hand_indices_keep, :]
        
        # reduce the samples of non exemplar and hand
        number = int(exemplar_hand_clip.shape[0] / 2)
        
        ind = np.arange(0, non_exemplar_clip.shape[0])
        np.random.shuffle(ind)
        non_exemplar_clip = non_exemplar_clip[0:number, :]
        
        ind = np.arange(0, exemplar_head_clip.shape[0])
        np.random.shuffle(ind)
        exemplar_head_clip = exemplar_head_clip[0:number, :]
        
        # collect per clip
        non_exemplar_feature_vectors_per_clip.append(non_exemplar_clip)
        exemplar_head_feature_vectors_per_clip.append(exemplar_head_clip)
        exemplar_hand_feature_vectors_per_clip.append(exemplar_hand_clip)
        
    n = datetime.datetime(1, 1, 1).now()
    timestamp = 'y{:d}m{:02d}d{:02d}-h{:02d}m{:02d}s{:02d}'. \
        format(n.year, n.month, n.day, n.hour, n.minute, n.second)
        
    classifier_name = 'fold_classifiers.' + timestamp + '.data'
    
    '''now we train a wonderful classifier'''
    
    
    
    indices = np.arange(len(clip_infos))
    
    accuracy_collect = []
    precision_collect = []
    recall_collect = []
    f1_collect = []
    
    print('')
    
    save = []
    roc_auc_collect = []
    
    for i in indices:
        
        ei = cv2.getTickCount()
        
        train_non_exemplar = non_exemplar_feature_vectors_per_clip.copy()
        train_exemplar_head = exemplar_head_feature_vectors_per_clip.copy()
        train_exemplar_hand = exemplar_hand_feature_vectors_per_clip.copy()
        
        
        val_test_non_exemplar = train_non_exemplar.pop(i)
        val_test_exemplar_head = train_exemplar_head.pop(i)
        val_test_exemplar_hand = train_exemplar_hand.pop(i)
        

        train_non_exemplar_lr = train_non_exemplar[7:]
        train_exemplar_head_lr = train_exemplar_head[7:]
        train_exemplar_hand_lr = train_exemplar_hand[7:]

        train_non_exemplar = train_non_exemplar[0:7]
        train_exemplar_head = train_exemplar_head[0:7]
        train_exemplar_hand = train_exemplar_hand[0:7]

   
        # stack
        train_non_exemplar = np.vstack(train_non_exemplar)
        train_exemplar_head = np.vstack(train_exemplar_head)
        train_exemplar_hand = np.vstack(train_exemplar_hand)
        
        train_non_exemplar_lr = np.vstack(train_non_exemplar_lr)
        train_exemplar_head_lr = np.vstack(train_exemplar_head_lr)
        train_exemplar_hand_lr = np.vstack(train_exemplar_hand_lr)
        
        
        X = np.vstack([train_non_exemplar,
                       train_exemplar_head,
                       train_exemplar_hand])
                
        X_lr = np.vstack([train_non_exemplar_lr,
                          train_exemplar_head_lr,
                          train_exemplar_hand_lr])

        X_LOO = np.vstack([val_test_non_exemplar,
                           val_test_exemplar_head,
                           val_test_exemplar_hand])
        
        # 0 for non-exemplar and exemplar head, 1 for exemplar hand
        y_train = np.hstack([np.zeros(len(train_non_exemplar)),
                             np.zeros(len(train_exemplar_head)),
                             np.ones(len(train_exemplar_hand))])

        y_train_lr = np.hstack([np.zeros(len(train_non_exemplar_lr)),
                             np.zeros(len(train_exemplar_head_lr)),
                             np.ones(len(train_exemplar_hand_lr))])
                
        y_val = np.hstack([np.zeros(len(val_test_non_exemplar)),
                           np.zeros(len(val_test_exemplar_head)),
                           np.ones(len(val_test_exemplar_hand))])

        print('X.shape', X.shape, ' (',
              'train_non_exemplar.shape', train_non_exemplar.shape,
              'train_exemplar_head.shape', train_exemplar_head.shape,
              'train_exemplar_hand.shape', train_exemplar_hand.shape,')')

        print('X_lr.shape', X_lr.shape, ' (',
              'train_non_exemplar_lr.shape', train_non_exemplar_lr.shape,
              'train_exemplar_head_lr.shape', train_exemplar_head_lr.shape,
              'train_exemplar_hand_lr.shape', train_exemplar_hand_lr.shape,')')
        
        # leave-one-out test
        print('X_LOO.shape', X_LOO.shape, ' (',
              'val_test_non_exemplar.shape', val_test_non_exemplar.shape,
              'val_test_exemplar_head.shape', val_test_exemplar_head.shape,
              'val_test_exemplar_hand.shape', val_test_exemplar_hand.shape,')')
        
        n_estimators = 50

        # Unsupervised transformation based on totally random trees
        rt = ske.RandomTreesEmbedding(max_depth=3, n_estimators=n_estimators)
        
        rt_lm = sklm.LogisticRegression()
        pipeline = skpi.make_pipeline(rt, rt_lm)
        pipeline.fit(X, y_train)
        y_pred_rt = pipeline.predict_proba(X_LOO)[:, 1]
        fpr_rt_lm, tpr_rt_lm, _ = skmet.roc_curve(y_val, y_pred_rt)
        roc_auc_rt_lm = skmet.roc_auc_score(y_val, y_pred_rt)
        
        
        # Supervised transformation based on random forests
        rf = ske.RandomForestClassifier(max_depth=3, n_estimators=n_estimators)
        rf_enc = skpr.OneHotEncoder()
        rf_lm = sklm.LogisticRegression()
        rf.fit(X, y_train)
        rf_enc.fit(rf.apply(X))
        rf_lm.fit(rf_enc.transform(rf.apply(X_lr)), y_train_lr)
        
        y_pred_rf_lm = rf_lm.predict_proba(rf_enc.transform(rf.apply(X_LOO)))[:, 1]
        fpr_rf_lm, tpr_rf_lm, _ = skmet.roc_curve(y_val, y_pred_rf_lm)
        roc_auc_rf_lm = skmet.roc_auc_score(y_val, y_pred_rf_lm)
        
        grd = ske.GradientBoostingClassifier(n_estimators=n_estimators)
        grd_enc = skpr.OneHotEncoder()
        grd_lm = sklm.LogisticRegression()
        grd.fit(X, y_train)
        grd_enc.fit(grd.apply(X)[:, :, 0])
        grd_lm.fit(grd_enc.transform(grd.apply(X_lr)[:, :, 0]), y_train_lr)
        
        y_pred_grd_lm = grd_lm.predict_proba(grd_enc.transform(grd.apply(X_LOO)[:, :, 0]))[:, 1]
        fpr_grd_lm, tpr_grd_lm, _ = skmet.roc_curve(y_val, y_pred_grd_lm)
        roc_auc_grd_lm = skmet.roc_auc_score(y_val, y_pred_grd_lm)
        
        # The gradient boosted model by itself
        y_pred_grd = grd.predict_proba(X_LOO)[:, 1]
        fpr_grd, tpr_grd, _ = skmet.roc_curve(y_val, y_pred_grd)
        roc_auc_grd = skmet.roc_auc_score(y_val, y_pred_grd)
        
        # The random forest model by itself
        y_pred_rf = rf.predict_proba(X_LOO)[:, 1]
        fpr_rf, tpr_rf, _ = skmet.roc_curve(y_val, y_pred_rf)
        roc_auc_rf = skmet.roc_auc_score(y_val, y_pred_rf)
        
        plt.figure(1)
        plt.plot([0, 1], [0, 1], 'k--')
        plt.plot(fpr_rt_lm, tpr_rt_lm, label='RT + LR' + ' ({:.2f})'.format(roc_auc_rt_lm))
        plt.plot(fpr_rf, tpr_rf, label='RF' + ' ({:.2f})'.format(roc_auc_rf))
        plt.plot(fpr_rf_lm, tpr_rf_lm, label='RF + LR' + ' ({:.2f})'.format(roc_auc_rf_lm))
        plt.plot(fpr_grd, tpr_grd, label='GBT' + ' ({:.2f})'.format(roc_auc_grd))
        plt.plot(fpr_grd_lm, tpr_grd_lm, label='GBT + LR' + ' ({:.2f})'.format(roc_auc_grd_lm))
        plt.xlabel('False positive rate')
        plt.ylabel('True positive rate')
        plt.title('ROC curve')
        plt.legend(loc='best')
        plt.show()        
 
        print(np.count_nonzero(rf.predict_proba(X_LOO)[:, 1] > 0.5),
              np.count_nonzero(grd.predict_proba(X_LOO)[:, 1] > 0.5),
              np.count_nonzero(grd_lm.predict_proba(grd_enc.transform(\
                                    grd.apply(X_LOO)[:, :, 0]))[:, 1] > 0.5), 
              np.count_nonzero(rf_lm.predict_proba(rf_enc.transform(\
                                    rf.apply(X_LOO)))[:, 1] > 0.5),
              np.count_nonzero(pipeline.predict_proba(X_LOO)[:, 1] > 0.5), )
              
        print(np.count_nonzero(y_val))       
        
        save.append([pipeline,
                     rf_lm,
                     grd_lm,
                     grd,
                     rf])
        roc_auc_collect.append([roc_auc_rt_lm,
                                roc_auc_rf_lm,
                                roc_auc_grd_lm,
                                roc_auc_grd,
                                roc_auc_rf])      
        


#        # random forest classifier
#        rf_clf = ske.RandomForestClassifier(n_estimators=50,
#                                            criterion='gini',
#                                            max_depth=2,
#                                            max_features=1,
#                                            max_leaf_nodes=7,
#                                            min_samples_split=500,
#                                            min_samples_leaf=5000,
#                                            min_weight_fraction_leaf=0.0,
#                                            min_impurity_decrease=0.1,
#                                            bootstrap=True,
#                                            oob_score=False,
#                                            n_jobs=-1,
#                                            random_state=None,
#                                            verbose=1,
#                                            warm_start=False,
#                                            class_weight='balanced_subsample')        
#        rf_clf.fit(X, y_train)
        y_predicted = rf.predict(X_LOO)
        



















                
#        '''
#        Defaults:
#        
#        n_estimators=10,
#        criterion='gini',
#        max_depth=None,
#        max_features='auto',
#        max_leaf_nodes=None,    
#        min_samples_split=2,
#        min_samples_leaf=1,
#        min_weight_fraction_leaf=0.0,
#        min_impurity_decrease=0.0,
#        bootstrap=True,
#        oob_score=False,
#        n_jobs=1,
#        random_state=None,
#        verbose=0,
#        warm_start=False,
#        class_weight=None   
#        '''
#        
#        param_distributions = {'n_estimators' : [50, 100],
#                               'criterion' : ['gini'],
#                               
#                               'max_depth' : [1, 2, 7],
#                               'max_features' : [1, 2, 6, 10],
#                               'max_leaf_nodes' : [2, 7, 20],
#                  
#                               'min_samples_split' : [2, 100, 1000, 5000],
#                               'min_samples_leaf' : [1, 100, 1000, 5000],
#                               'min_weight_fraction_leaf' : [0.0],
#                               'min_impurity_decrease' : [0.01, 0.1],
#                               'bootstrap' : [True],
#                               'oob_score' : [False],
#                               'n_jobs' : [-1],
#                               'random_state' : [None],
#                               'verbose' : [1],
#                               'warm_start' : [False],
#                               'class_weight' : ['balanced_subsample']}  
#        ei = cv2.getTickCount()
#        

##        rf_clf = ske.RandomForestClassifier()
##        rs_rf_clf = sklms.RandomizedSearchCV(rf_clf, param_distributions,
##            n_iter=50, scoring=skmet.make_scorer(skmet.f1_score, labels=[0, 1],
##            average='macro'), n_jobs=1, verbose=2)
##                
##        #train
##        rs_rf_clf.fit(X, y_train)
##        
##        save.append(rs_rf_clf)
#        
#        knn_clf = skn.KNeighborsClassifier(n_neighbors=5)
#        knn_clf.fit(X, y_train)
#        save.append(knn_clf)
#        y_predicted = knn_clf.predict(X_LOO)
#        
##        rf_clf.fit(X, y_train)
##        save.append(rf_clf)
#
#        
##        y_predicted = rf_clf.predict(X_LOO)
##        y_predicted = rs_rf_clf.best_estimator_.predict(X_LOO)
#        
        # report
        accuracy = skmet.accuracy_score(y_val, y_predicted)
        precision = skmet.precision_score(y_val, y_predicted, labels=[0, 1, 2],
                                          average=None)
        recall = skmet.recall_score(y_val, y_predicted, labels=[0, 1, 2],
                                    average=None)
        f1 = skmet.f1_score(y_val, y_predicted, labels=[0, 1, 2], average=None)
        
        accuracy_collect.append(accuracy)
        precision_collect.append(precision)
        recall_collect.append(recall)
        f1_collect.append(f1)
        
        header_row    = '           non-exemplar     exemplar-head     exemplar-hand'
        precision_row = 'Precision  {:12.3f}     {:13.3f}     {:13.3f}'
        recall_row    = 'Recall     {:12.3f}     {:13.3f}     {:13.3f}'
        f1_row        = 'F1 score   {:12.3f}     {:13.3f}     {:13.3f}'
        accuracy_row  = 'Accuracy  {:12.3f}'
        
        print(accuracy_row.format(accuracy))
        print('confusion matrix:\n', skmet.confusion_matrix(y_val, y_predicted))
        print(header_row)
        print(precision_row.format(precision[0], precision[1], precision[2]))
        print(recall_row.format(recall[0], recall[1], recall[2]))
        print(f1_row.format(f1[0], f1[1], f1[2]))
        
        ee = cv2.getTickCount()
        print("Per LOO execution {:.2f} seconds".format(\
            (ee - ei) / cv2.getTickFrequency()))
    
    print('tag:\n', tag)
    
    for ftype in ftypes:
        print(ftype)
    
    
    accuracy_collect = np.vstack(accuracy_collect)
    precision_collect = np.vstack(precision_collect)
    recall_collect = np.vstack(recall_collect)
    f1_collect = np.vstack(f1_collect)
    
    
    accuracy_row  = 'Accuracy'
    minimum_row   = '          Minimum    {:12.3f}'
    median_row    = '          Median     {:12.3f}'
    mean_row      = '          Mean       {:12.3f}'
    maximum_row   = '          Maximum    {:12.3f}'
    
    print(accuracy_row)
    print(minimum_row.format(np.min(accuracy_collect)))
    print(median_row.format(np.median(accuracy_collect)))
    print(mean_row.format(np.mean(accuracy_collect)))
    print(maximum_row.format(np.max(accuracy_collect)))
    
    precision_row = 'Precision          non-exemplar     exemplar-head     exemplar-hand'
    recall_row    = 'Recall             non-exemplar     exemplar-head     exemplar-hand'
    minimum_row   = '          Minimum  {:12.3f}     {:13.3f}     {:13.3f}'
    median_row    = '          Median   {:12.3f}     {:13.3f}     {:13.3f}'
    mean_row      = '          Mean     {:12.3f}     {:13.3f}     {:13.3f}'
    maximum_row   = '          Maximum  {:12.3f}     {:13.3f}     {:13.3f}'
    
    print(precision_row)
    print(minimum_row.format(np.min(precision_collect[:, 0]), 
                             np.min(precision_collect[:, 1]),
                             np.min(precision_collect[:, 2])))
    print(median_row.format(np.median(precision_collect[:, 0]),
                            np.median(precision_collect[:, 1]),
                            np.median(precision_collect[:, 2])))
    print(mean_row.format(np.mean(precision_collect[:, 0]),
                          np.mean(precision_collect[:, 1]),
                          np.mean(precision_collect[:, 2])))
    print(maximum_row.format(np.max(precision_collect[:, 0]),
                             np.max(precision_collect[:, 1]),
                             np.max(precision_collect[:, 2])))
    
    print(recall_row)
    print(minimum_row.format(np.min(recall_collect[:, 0]), 
                             np.min(recall_collect[:, 1]),
                             np.min(recall_collect[:, 2]),))
    print(median_row.format(np.median(recall_collect[:, 0]),
                            np.median(recall_collect[:, 1]),
                            np.median(recall_collect[:, 2]),))
    print(mean_row.format(np.mean(recall_collect[:, 0]),
                          np.mean(recall_collect[:, 1]),
                          np.mean(recall_collect[:, 2])))
    print(maximum_row.format(np.max(recall_collect[:, 0]),
                             np.max(recall_collect[:, 1]),
                             np.max(recall_collect[:, 2]),))

    roc_auc_collect = np.vstack(roc_auc_collect)
                
    roc_auc_row   = 'ROC AUC             RT + LR      RF    RF + LR    GBT  GBT + LR'
    minimum_row   = '          Minimum  {:7.3f}  {:7.3f}  {:7.3f}  {:7.3f}  {:7.3f}'
    median_row    = '          Median   {:7.3f}  {:7.3f}  {:7.3f}  {:7.3f}  {:7.3f}'
    mean_row      = '          Mean     {:7.3f}  {:7.3f}  {:7.3f}  {:7.3f}  {:7.3f}'
    maximum_row   = '          Maximum  {:7.3f}  {:7.3f}  {:7.3f}  {:7.3f}  {:7.3f}'
    
    print(roc_auc_row)
    print(minimum_row.format(np.min(roc_auc_collect[:, 0]), 
                             np.min(roc_auc_collect[:, 4]),
                             np.min(roc_auc_collect[:, 1]),
                             np.min(roc_auc_collect[:, 3]),
                             np.min(roc_auc_collect[:, 2])))
    print(median_row.format(np.median(roc_auc_collect[:, 0]), 
                            np.median(roc_auc_collect[:, 4]),
                            np.median(roc_auc_collect[:, 1]),
                            np.median(roc_auc_collect[:, 3]),
                            np.median(roc_auc_collect[:, 2])))
    print(mean_row.format(np.mean(roc_auc_collect[:, 0]), 
                          np.mean(roc_auc_collect[:, 4]),
                          np.mean(roc_auc_collect[:, 1]),
                          np.mean(roc_auc_collect[:, 3]),
                          np.mean(roc_auc_collect[:, 2])))
    print(maximum_row.format(np.max(roc_auc_collect[:, 0]), 
                             np.max(roc_auc_collect[:, 4]),
                             np.max(roc_auc_collect[:, 1]),
                             np.max(roc_auc_collect[:, 3]),
                             np.max(roc_auc_collect[:, 2])))

    
    # pickle
    with open('./wheeler/dataset/three_way_classify/'+classifier_name, 'wb') as f:
        pickle.dump((tags, save), f)
    
    e2 = cv2.getTickCount()
    print("Total execution {:.2f} seconds".format(\
        (e2 - e1) / cv2.getTickFrequency()))


