# -*- coding: utf-8 -*-
"""
Created on Wed May 16 08:29:45 2018

@author: Callie Darsey

three_class_02
"""


import pickle
import numpy as np
import sklearn.ensemble as ske
import sklearn.metrics as skmet
import sklearn.neighbors as skn
import sklearn.linear_model as sklm
import sklearn.model_selection as sklms
import matplotlib.pyplot as plt
import cv2
import sklearn.tree as sklt

def merge_my_dicts(d_list):
    '''
    '''
    my_merged_dict = {}
    
    for key in d_list[0].keys():
        #print(key)
        
        for d in d_list[1:]:
            assert key in d.keys()
            assert np.count_nonzero([d_list[0][key][0] != d[key][0]]) == 0
            assert d_list[0][key][1] == d[key][1]
            
        val = [d_list[0][key][0], d_list[0][key][1]]
        
        features = []
        
        for d in d_list:
            
            features = features + [d[key][2]]
            
        val = val + [np.hstack(features)]

        my_merged_dict[key] = val
        
    return my_merged_dict


        
e1 = cv2.getTickCount()

upper = './wheeler/dataset/'
tags = ['patches_labels_and_subset_feature_gray_skin_Bins_32.uint8___']

ftypes = ['gray skin uint8 28 x 28']

clip_infos = [[]] * 15

for tag in tags:
    
    clip_info = [\
    upper + 'part1/MVI_0069_trans/' + tag + 'MVI_0069_trans__0_100.data',
    upper + 'STI_Polk_Apr13_C/MVI_0039_trans/' + tag + 'MVI_0039_trans__460_563.data',
    upper + 'STI_Polk_Apr27_A/MVI_0073_trans/' + tag + 'MVI_0073_trans__0_100.data',
    upper + 'STI_Polk_Apr27_D/MVI_0063_trans/' + tag + 'MVI_0074_trans__240_342.data',
    upper + 'STI_Polk_May04_A/MVI_0087_trans/' + tag + 'MVI_0087_trans__579_680.data',
    upper + 'STI_Polk_May11_C/MVI_0108_trans/' + tag + 'MVI_0108_trans__0_42.data',
    upper + 'STI_WA_Apr11_extra_B/MVI_0036_trans/' + tag + 'MVI_0036_trans__870_912.data',
    upper + 'STI_WA_Jun12_B/MVI_0018_trans/' + tag + 'MVI_0018_trans__910_954.data',
    upper + 'STI_WA_Jun14_Lb/MVI_0070_trans/' + tag + 'MVI_0070_trans__670_712.data',
    upper + 'STI_WA_Jun20_CT/MVI_0029_trans/' + tag + 'MVI_0029_trans__515_557.data',
    upper + 'STI_WA_Jun22_De/MVI_0118_trans/' + tag + 'MVI_0118_trans__100_142.data',
    upper + 'STI_WA_Jun23_Da/MVI_0112_trans/' + tag + 'MVI_0112_trans__15_57.data',
    upper + 'STI_WA_May02_B/MVI_0053_trans/' + tag + 'MVI_0053_trans__0_100.data',
    upper + 'STI_WA_May02_C/MVI_0074_trans/' + tag + 'MVI_0074_trans__60_102.data',
    upper + 'STI_WA_May09_A/MVI_0109_trans/' + tag + 'MVI_0109_trans__0_42.data']
    
    for i, data in enumerate(clip_info):
        
        clip_infos[i] = clip_infos[i] + [data]


segment = 45

# holds head and hand feature vectors per clip

non_exemplar_feature_vectors_per_clip = []
exemplar_head_feature_vectors_per_clip = []
exemplar_hand_feature_vectors_per_clip = []

for clip in clip_infos:
    
    patches_infos = []
    
    for data in clip:
        
        with open(data, 'rb') as f:
            
            patches_info = pickle.load(f)
            
        patches_infos.append(patches_info)
    
    patches_info_merged = merge_my_dicts(patches_infos)
    

    non_exemplar_clip = []
    exemplar_head_clip = []
    exemplar_hand_clip = []
        
    for info in patches_info_merged.values():
        
        patches, tags, feature = info[0], info[1], info[2]
        
        tags_ar = np.array(tags)
        
        
        # group according to tags
        non_exemplar_indices = \
            np.where(tags_ar == 'predominately non-exemplar')[0]        
        
        
        exemplar_head_indices = np.where(np.any(\
                                            [tags_ar == 'predominately head',
                                            tags_ar == 'predominately both'],
                                            axis=0))[0]

        exemplar_hand_indices = np.where(tags_ar == 'predominately hand')[0]        

        # features
        if len(non_exemplar_indices) > 0:

            non_exemplar_clip.append(feature[non_exemplar_indices, :])            
        
        if len(exemplar_head_indices) > 0:
            
            exemplar_head_clip.append(feature[exemplar_head_indices, :])
            
        if len(exemplar_hand_indices) > 0:
            
            exemplar_hand_clip.append(feature[exemplar_hand_indices, :])
            
    # stack for clip
    non_exemplar_clip = np.vstack(non_exemplar_clip)
    exemplar_head_clip = np.vstack(exemplar_head_clip)
    exemplar_hand_clip = np.vstack(exemplar_hand_clip)
    
    
    # collect per clip
    non_exemplar_feature_vectors_per_clip.append(non_exemplar_clip)
    exemplar_head_feature_vectors_per_clip.append(exemplar_head_clip)
    exemplar_hand_feature_vectors_per_clip.append(exemplar_hand_clip)
    

# boxplots
non_exemplars = np.vstack(non_exemplar_feature_vectors_per_clip)
exemplars_head = np.vstack(exemplar_head_feature_vectors_per_clip)
exemplars_hand = np.vstack(exemplar_hand_feature_vectors_per_clip)


for i, ftype in enumerate(ftypes):

    plt.figure(figsize=(10, 9))
    plt.subplot(131)
    e_bp = plt.boxplot(non_exemplars[:, i])
    plt.title('non_exemplars - ' + ftype)
    #plt.ylim(-500, 300000)
    
    plt.subplot(132)
    ne_bp = plt.boxplot(exemplars_head[:, i])
    plt.title('exemplars_head - ' + ftype)
    #plt.ylim(-500, 300000)
    plt.show()
    
    plt.subplot(133)
    ne_bp = plt.boxplot(exemplars_hand[:, i])
    plt.title('exemplars_hand - ' + ftype)
    #plt.ylim(-500, 300000)
    plt.show()

indices = np.arange(len(clip_infos))

accuracy_collect = []
precision_collect = []
recall_collect = []
f1_collect = []

print('')

save = []

for i in indices:
    
    train_non_exemplar = non_exemplar_feature_vectors_per_clip.copy()
    train_exemplar_head = exemplar_head_feature_vectors_per_clip.copy()
    train_exemplar_hand = exemplar_hand_feature_vectors_per_clip.copy()
    
    
    val_test_exemplar_head = train_exemplar_head.pop(i)
    val_test_exemplar_hand = train_exemplar_hand.pop(i)
    val_test_non_exemplar = train_non_exemplar.pop(i)
    
    # stack
    train_non_exemplar = np.vstack(train_non_exemplar)
    train_exemplar_head = np.vstack(train_exemplar_head)
    train_exemplar_hand = np.vstack(train_exemplar_hand)
   
    
    X = np.vstack([train_non_exemplar,
                   train_exemplar_head,
                   train_exemplar_hand])
    
    print('X.shape', X.shape, ' (',
          'train_non_exemplar.shape', train_non_exemplar.shape,                       
          'train_exemplar_head.shape', train_exemplar_head.shape,
          'train_exemplar_hand.shape', train_exemplar_hand.shape,')')
        
    X_LOO = np.vstack([val_test_non_exemplar,
                       val_test_exemplar_head,
                       val_test_exemplar_hand])
    
    # 0 for non-exemplar, 1 for exemplar
    y_train = np.hstack([np.zeros(len(train_non_exemplar)),
                         np.ones(len(train_exemplar_head)),
                         np.ones(len(train_exemplar_hand)) * 2])
            
    y_val = np.hstack([np.zeros(len(val_test_non_exemplar)),
                       np.ones(len(val_test_exemplar_head)),
                       np.ones(len(val_test_exemplar_hand)) * 2])
    '''
    Defaults:
    
    n_estimators=10,
    criterion='gini',
    max_depth=None,
    max_features='auto',
    max_leaf_nodes=None,    
    min_samples_split=2,
    min_samples_leaf=1,
    min_weight_fraction_leaf=0.0,
    min_impurity_split=1e-07,
    bootstrap=True,
    oob_score=False,
    n_jobs=1,
    random_state=None,
    verbose=0,
    warm_start=False,
    class_weight=None   
    '''
    
    param_distributions = {'n_estimators' : [20, 50, 100],
                           'criterion' : ['gini'],
                           
                           'max_depth' : [1, 2, 3, 5],
                           'max_features' : [1, 2, 6, 10],
                           'max_leaf_nodes' : [3, 5, 7],
              
                           'min_samples_split' : [2, 100, 200],
                           'min_samples_leaf' : [1, 50, 100, 1000],
                           'min_weight_fraction_leaf' : [0.0],
                           'min_impurity_split' : [1e-7, 1e-4, 0.1],
                           'bootstrap' : [True],
                           'oob_score' : [False],
                           'n_jobs' : [-1],
                           'random_state' : [None],
                           'verbose' : [1],
                           'warm_start' : [False],
                           'class_weight' : ['balanced', 'balanced_subsample']}  
    ei = cv2.getTickCount()
    
    # random forest classifier
    rf_clf = ske.RandomForestClassifier()
#    rf_clf = ske.RandomForestClassifier(n_estimators=n_estimators,
#                                        max_depth=3,
#                                        max_features=2,
#                                        max_leaf_nodes=3,
#                                        min_impurity_split=1e-4,
#                                        min_samples_leaf=1,
#                                        min_samples_split=2,
#                                        class_weight='balanced',
#                                        n_jobs=-1)
    rs_rf_clf = sklms.RandomizedSearchCV(rf_clf, param_distributions,
                                         n_iter=20,
                                         scoring=skmet.make_scorer(\
                                            skmet.f1_score, labels=[1, 2],
                                            average='weighted'), n_jobs=1,
                                            verbose=2)
    
#    knn_clf = skn.KNeighborsClassifier(51)
    
#    knn_clf = sklm.LogisticRegression()
        
    # train
    rs_rf_clf.fit(X, y_train)
    
    save.append(rs_rf_clf)
    
    # leave-one-out test
    print('X_LOO.shape', X_LOO.shape, ' (',
          'val_test_non_exemplar.shape', val_test_non_exemplar.shape,
          'val_test_exemplar_head.shape', val_test_exemplar_head.shape,
          'val_test_exemplar_hand.shape', val_test_exemplar_hand.shape,')')
    
    y_predicted = rs_rf_clf.predict(X_LOO)
#    y_predicted = np.zeros_like(y_val)
#    y_predicted[np.where(X_LOO > 0)[0]] = 1 

    # report
    accuracy = skmet.accuracy_score(y_val, y_predicted)
    precision = skmet.precision_score(y_val, y_predicted, labels=[0, 1, 2],
                                      average=None)
    recall = skmet.recall_score(y_val, y_predicted, labels=[0, 1, 2],
                                average=None)
    f1 = skmet.f1_score(y_val, y_predicted, labels=[0, 1, 2], average=None)
    
    accuracy_collect.append(accuracy)
    precision_collect.append(precision)
    recall_collect.append(recall)
    f1_collect.append(f1)
    
    header_row    = '           non-exemplar     exemplar-head     exemplar-hand'
    precision_row = 'Precision  {:12.3f}     {:13.3f}     {:13.3f}'
    recall_row    = 'Recall     {:12.3f}     {:13.3f}     {:13.3f}'
    f1_row        = 'F1 score   {:12.3f}     {:13.3f}     {:13.3f}'
    accuracy_row  = 'Accuracy  {:12.3f}'
    
    print(accuracy_row.format(accuracy))
    print('confusion matrix:\n', skmet.confusion_matrix(y_val, y_predicted))
    print(header_row)
    print(precision_row.format(precision[0], precision[1], precision[2]))
    print(recall_row.format(recall[0], recall[1], recall[2]))
    print(f1_row.format(f1[0], f1[1], f1[2]))
    
    ee = cv2.getTickCount()
    print("Per LOO execution {:.2f} seconds".format(\
        (ee - ei) / cv2.getTickFrequency()))

print('tag:', tag)
for ftype in ftypes:
    print(ftype)


accuracy_collect = np.vstack(accuracy_collect)
precision_collect = np.vstack(precision_collect)
recall_collect = np.vstack(recall_collect)
f1_collect = np.vstack(f1_collect)


accuracy_row  = 'Accuracy'
minimum_row   = '          Minimum    {:12.3f}'
median_row    = '          Median     {:12.3f}'
mean_row      = '          Mean       {:12.3f}'
maximum_row   = '          Maximum    {:12.3f}'

print(accuracy_row)
print(minimum_row.format(np.min(accuracy_collect)))
print(median_row.format(np.median(accuracy_collect)))
print(mean_row.format(np.mean(accuracy_collect)))
print(maximum_row.format(np.max(accuracy_collect)))

precision_row = 'Precision          non-exemplar     exemplar-head     exemplar-hand'
recall_row    = 'Recall             non-exemplar     exemplar-head     exemplar-hand'
minimum_row   = '          Minimum  {:12.3f}     {:13.3f}     {:13.3f}'
median_row    = '          Median   {:12.3f}     {:13.3f}     {:13.3f}'
mean_row      = '          Mean     {:12.3f}     {:13.3f}     {:13.3f}'
maximum_row   = '          Maximum  {:12.3f}     {:13.3f}     {:13.3f}'

print(precision_row)
print(minimum_row.format(np.min(precision_collect[:, 0]), 
                         np.min(precision_collect[:, 1]),
                         np.min(precision_collect[:, 2])))
print(median_row.format(np.median(precision_collect[:, 0]),
                        np.median(precision_collect[:, 1]),
                        np.median(precision_collect[:, 2])))
print(mean_row.format(np.mean(precision_collect[:, 0]),
                      np.mean(precision_collect[:, 1]),
                      np.mean(precision_collect[:, 2])))
print(maximum_row.format(np.max(precision_collect[:, 0]),
                         np.max(precision_collect[:, 1]),
                         np.max(precision_collect[:, 2])))

print(recall_row)
print(minimum_row.format(np.min(recall_collect[:, 0]), 
                         np.min(recall_collect[:, 1]),
                         np.min(recall_collect[:, 2]),))
print(median_row.format(np.median(recall_collect[:, 0]),
                        np.median(recall_collect[:, 1]),
                        np.median(recall_collect[:, 2]),))
print(mean_row.format(np.mean(recall_collect[:, 0]),
                      np.mean(recall_collect[:, 1]),
                      np.mean(recall_collect[:, 2])))
print(maximum_row.format(np.max(recall_collect[:, 0]),
                         np.max(recall_collect[:, 1]),
                         np.max(recall_collect[:, 2]),))

# pickle
with open('./wheeler/dataset/three_way_classify/save.data', 'wb') as f:
    pickle.dump(save, f)

e2 = cv2.getTickCount()
print("Total execution {:.2f} seconds".format(\
    (e2 - e1) / cv2.getTickFrequency()))