# -*- coding: utf-8 -*-
"""
Created on Thu Feb 22 13:01:55 2018

@author: Callie Darsey

trying out reshaping
"""

import cv2
import numpy as np

def print_one_channel_image(image):
    
    for row in image:
        s = ''
        for element in row:
            s = s + '{:3d}'.format(element) + ', '
        print(s)
    print('')
    
def print_row(row_array):
    s = ''
    for element in row_array:
        s = s + '{:3d}, '.format(element)
    print(s)
    print('')

linear = np.array([[[1, 2, 3], [1, 2, 3]], [[1, 2, 3], [1, 2, 3]]])
squared = np.array([[[16, 25, 36], [16, 25, 36]],
                    [[16, 25, 36], [16, 25, 36]]])
cubed = np.array([[[343, 512, 729], [343, 512, 729]],
                  [[343, 512, 729], [343, 512, 729]]])
times2 = np.array([[[20, 22, 24], [20, 22, 24]], [[20, 22, 24], [20, 22, 24]]])

out = np.stack([linear, squared, cubed, times2], axis=2)

print('out.shape', out.shape)

out_reshaped = np.reshape(out, (2, 2, 12))

print(out_reshaped, '\n')
print_row(out_reshaped[0, 0, :])
print_row(out_reshaped[0, 0, :])
print_row(out_reshaped[1, 0, :])
print_row(out_reshaped[1, 1, :])

print(np.count_nonzero(out_reshaped[:,:,0:3]  == linear) == linear.size)
print(np.count_nonzero(out_reshaped[:,:,3:6]  == squared) == squared.size)
print(np.count_nonzero(out_reshaped[:,:,6:9]  == cubed) == cubed.size)
print(np.count_nonzero(out_reshaped[:,:,9:12] == times2) == times2.size)